package sensei.middleware.domains;


/**
* sensei/middleware/domains/DomainGroupHandlerOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
        * GroupMember targetted as central instance to handle several subgroups
        * Messages sent through this class must belong to the DomainMessage hierarchy
        *
        *   -	It allows to define several subgroups to be handled separately by one group.
        *   - The subgroups can be created/removed dynamically.
        *   -	It includes the abstraction group/subgroups or domain/groups
        * It supports several special features:
        * -The sending of messages blocks the caller until the message is received
        * -Reception of cast messages sent by the own member are not propagated to the
        *    subgroups: they just unblock the message sending.
        * -PTP messages can be sent to all the subgroups in the group
        * -State transfer support
        * -Replica properties support
        * -Transactions support
        **/
public interface DomainGroupHandlerOperations  extends sensei.middleware.gms.GroupHandlerOperations, sensei.middleware.gms.GroupMemberOperations, sensei.middleware.domains.PropertiesHandlerOperations, sensei.middleware.domains.SubgroupsHandlerOperations, sensei.middleware.domains.TransactionsHandlerOperations
{

  /**
           * Sets the mode under view changes. It can only be set before the domain Group Handler joins a group,
           * or an exception is thrown
           */
  void setBehaviourMode (sensei.middleware.domains.BehaviourOnViewChanges mode) throws sensei.middleware.domains.MemberStateException;

  /**
           * Sets a coordinator elector. It must be set before the DomainGroupHandler joins a group, or an
           * exception is raised
           */
  void setCoordinatorElector (sensei.middleware.domains.CoordinatorElector elector) throws sensei.middleware.domains.MemberStateException;

  /**
           * Sets a listener to DomainGroup events. It must be set before the DomainGroupHandler joins a group, or an
           * exception is raised
           */
  void setDomainGroupUser (sensei.middleware.domains.DomainGroupUser user) throws sensei.middleware.domains.MemberStateException;

  /**
           * Returns the list of stateful members. This operation can only be invoked on stateful members,
           * or an exception is thrown
           */
  int[] getStatefulMembers () throws sensei.middleware.domains.MemberStateException;

  /**
            * Cast a message to the subgroup, and blocks until it is processed.
            * @param normalProcessing set to true if the message is to be received through the normal
            *        processCastMessage. In that case, this call blocks until the message is processed.
            *        If it is false, the call blocks until the caller can process the operation, and
            *        when it finishes, it must call to syncCastDomainMessageProcessed
            **/
  boolean syncCastDomainMessage (sensei.middleware.domains.DomainMessage message, boolean normalProcessing) throws sensei.middleware.domains.MemberStateException;

  /**
            * Confirms that a message has been processed. Failing to call to this method after
            *   requesting syncCastDomainMessage with normalProcessing equal to false will avoid the
            *   normal flow of messages into the application, excluding eventually the member from the group
            **/
  void syncCastDomainMessageProcessed () throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SyncCastDomainMessageProcessedException;
} // interface DomainGroupHandlerOperations
