package sensei.middleware.domains;


/**
* sensei/middleware/domains/DomainGroupHandlerPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
        * GroupMember targetted as central instance to handle several subgroups
        * Messages sent through this class must belong to the DomainMessage hierarchy
        *
        *   -	It allows to define several subgroups to be handled separately by one group.
        *   - The subgroups can be created/removed dynamically.
        *   -	It includes the abstraction group/subgroups or domain/groups
        * It supports several special features:
        * -The sending of messages blocks the caller until the message is received
        * -Reception of cast messages sent by the own member are not propagated to the
        *    subgroups: they just unblock the message sending.
        * -PTP messages can be sent to all the subgroups in the group
        * -State transfer support
        * -Replica properties support
        * -Transactions support
        **/
public abstract class DomainGroupHandlerPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.DomainGroupHandlerOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("setBehaviourMode", new java.lang.Integer (0));
    _methods.put ("setCoordinatorElector", new java.lang.Integer (1));
    _methods.put ("setDomainGroupUser", new java.lang.Integer (2));
    _methods.put ("getStatefulMembers", new java.lang.Integer (3));
    _methods.put ("syncCastDomainMessage", new java.lang.Integer (4));
    _methods.put ("syncCastDomainMessageProcessed", new java.lang.Integer (5));
    _methods.put ("getGroupMemberId", new java.lang.Integer (6));
    _methods.put ("isValidGroup", new java.lang.Integer (7));
    _methods.put ("leaveGroup", new java.lang.Integer (8));
    _methods.put ("castMessage", new java.lang.Integer (9));
    _methods.put ("sendMessage", new java.lang.Integer (10));
    _methods.put ("processPTPMessage", new java.lang.Integer (11));
    _methods.put ("processCastMessage", new java.lang.Integer (12));
    _methods.put ("memberAccepted", new java.lang.Integer (13));
    _methods.put ("changingView", new java.lang.Integer (14));
    _methods.put ("installView", new java.lang.Integer (15));
    _methods.put ("excludedFromGroup", new java.lang.Integer (16));
    _methods.put ("enableProperties", new java.lang.Integer (17));
    _methods.put ("arePropertiesEnabled", new java.lang.Integer (18));
    _methods.put ("setPropertiesListener", new java.lang.Integer (19));
    _methods.put ("getAllProperties", new java.lang.Integer (20));
    _methods.put ("getPropertyForAllMembers", new java.lang.Integer (21));
    _methods.put ("getMemberProperties", new java.lang.Integer (22));
    _methods.put ("getMemberProperty", new java.lang.Integer (23));
    _methods.put ("getProperties", new java.lang.Integer (24));
    _methods.put ("getProperty", new java.lang.Integer (25));
    _methods.put ("setProperties", new java.lang.Integer (26));
    _methods.put ("addProperties", new java.lang.Integer (27));
    _methods.put ("removeProperties", new java.lang.Integer (28));
    _methods.put ("setDynamicSubgroupsUser", new java.lang.Integer (29));
    _methods.put ("registerSubgroup", new java.lang.Integer (30));
    _methods.put ("castSubgroupCreation", new java.lang.Integer (31));
    _methods.put ("createSubgroup", new java.lang.Integer (32));
    _methods.put ("removeSubgroup", new java.lang.Integer (33));
    _methods.put ("getSubgroups", new java.lang.Integer (34));
    _methods.put ("getSubgroup", new java.lang.Integer (35));
    _methods.put ("getSubgroupId", new java.lang.Integer (36));
    _methods.put ("startTransaction", new java.lang.Integer (37));
    _methods.put ("endTransaction", new java.lang.Integer (38));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
           * Sets the mode under view changes. It can only be set before the domain Group Handler joins a group,
           * or an exception is thrown
           */
       case 0:  // sensei/middleware/domains/DomainGroupHandler/setBehaviourMode
       {
         try {
           sensei.middleware.domains.BehaviourOnViewChanges mode = sensei.middleware.domains.BehaviourOnViewChangesHelper.read (in);
           this.setBehaviourMode (mode);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Sets a coordinator elector. It must be set before the DomainGroupHandler joins a group, or an
           * exception is raised
           */
       case 1:  // sensei/middleware/domains/DomainGroupHandler/setCoordinatorElector
       {
         try {
           sensei.middleware.domains.CoordinatorElector elector = sensei.middleware.domains.CoordinatorElectorHelper.read (in);
           this.setCoordinatorElector (elector);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Sets a listener to DomainGroup events. It must be set before the DomainGroupHandler joins a group, or an
           * exception is raised
           */
       case 2:  // sensei/middleware/domains/DomainGroupHandler/setDomainGroupUser
       {
         try {
           sensei.middleware.domains.DomainGroupUser user = sensei.middleware.domains.DomainGroupUserHelper.read (in);
           this.setDomainGroupUser (user);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the list of stateful members. This operation can only be invoked on stateful members,
           * or an exception is thrown
           */
       case 3:  // sensei/middleware/domains/DomainGroupHandler/getStatefulMembers
       {
         try {
           int $result[] = null;
           $result = this.getStatefulMembers ();
           out = $rh.createReply();
           sensei.middleware.gms.GroupMemberIdListHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Cast a message to the subgroup, and blocks until it is processed.
            * @param normalProcessing set to true if the message is to be received through the normal
            *        processCastMessage. In that case, this call blocks until the message is processed.
            *        If it is false, the call blocks until the caller can process the operation, and
            *        when it finishes, it must call to syncCastDomainMessageProcessed
            **/
       case 4:  // sensei/middleware/domains/DomainGroupHandler/syncCastDomainMessage
       {
         try {
           sensei.middleware.domains.DomainMessage message = sensei.middleware.domains.DomainMessageHelper.read (in);
           boolean normalProcessing = in.read_boolean ();
           boolean $result = false;
           $result = this.syncCastDomainMessage (message, normalProcessing);
           out = $rh.createReply();
           out.write_boolean ($result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Confirms that a message has been processed. Failing to call to this method after
            *   requesting syncCastDomainMessage with normalProcessing equal to false will avoid the
            *   normal flow of messages into the application, excluding eventually the member from the group
            **/
       case 5:  // sensei/middleware/domains/DomainGroupHandler/syncCastDomainMessageProcessed
       {
         try {
           this.syncCastDomainMessageProcessed ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SyncCastDomainMessageProcessedException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SyncCastDomainMessageProcessedExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Returns the GroupMemberId handled by this GroupHandler
            * If the member is not active, the returned value is random - negative.
            **/
       case 6:  // sensei/middleware/gms/GroupHandler/getGroupMemberId
       {
         int $result = (int)0;
         $result = this.getGroupMemberId ();
         out = $rh.createReply();
         out.write_long ($result);
         break;
       }


  /**
            * Returns true if the member belong to a group
            **/
       case 7:  // sensei/middleware/gms/GroupHandler/isValidGroup
       {
         boolean $result = false;
         $result = this.isValidGroup ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Leaves the group
            * @returns true if the member was belonging to a group
            **/
       case 8:  // sensei/middleware/gms/GroupHandler/leaveGroup
       {
         boolean $result = false;
         $result = this.leaveGroup ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Sends a message to every member in the view, returning
            * true if the message is sent on this view
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
       case 9:  // sensei/middleware/gms/GroupHandler/castMessage
       {
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         boolean $result = false;
         $result = this.castMessage (msg);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Sends a message to the specified member in the view, returning
            * true if the message is sent on this view. This call allows
            * to keep the order between cast and point-to-point messages
            * @param target The member receiving the message
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
       case 10:  // sensei/middleware/gms/GroupHandler/sendMessage
       {
         int target = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         boolean $result = false;
         $result = this.sendMessage (target, msg);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
       case 11:  // sensei/middleware/gms/GroupMember/processPTPMessage
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         this.processPTPMessage (sender, msg);
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
       case 12:  // sensei/middleware/gms/GroupMember/processCastMessage
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         this.processCastMessage (sender, msg);
         out = $rh.createReply();
         break;
       }


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
       case 13:  // sensei/middleware/gms/GroupMember/memberAccepted
       {
         int identity = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.GroupHandler handler = sensei.middleware.gms.GroupHandlerHelper.read (in);
         sensei.middleware.gms.View theView = sensei.middleware.gms.ViewHelper.read (in);
         this.memberAccepted (identity, handler, theView);
         out = $rh.createReply();
         break;
       }


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
       case 14:  // sensei/middleware/gms/GroupMember/changingView
       {
         this.changingView ();
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
       case 15:  // sensei/middleware/gms/GroupMember/installView
       {
         sensei.middleware.gms.View theView = sensei.middleware.gms.ViewHelper.read (in);
         this.installView (theView);
         out = $rh.createReply();
         break;
       }


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
       case 16:  // sensei/middleware/gms/GroupMember/excludedFromGroup
       {
         this.excludedFromGroup ();
         out = $rh.createReply();
         break;
       }


  /**
           * Enables the use of properties, which is disabled by default.
           * This method must be invoked before the member joins the group, or an exception is raised.
           * Every member in the group must use the same properties
           * policy.
           */
       case 17:  // sensei/middleware/domains/PropertiesHandler/enableProperties
       {
         try {
           this.enableProperties ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the properties policy
           */
       case 18:  // sensei/middleware/domains/PropertiesHandler/arePropertiesEnabled
       {
         boolean $result = false;
         $result = this.arePropertiesEnabled ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
           * Sets a PropertiesListener, that will receive the properties update notifications. The user
           * can be set at any moment, and if a nil user is specified, no user will be used.
           */
       case 19:  // sensei/middleware/domains/PropertiesHandler/setPropertiesListener
       {
         try {
           sensei.middleware.domains.PropertiesListener listener = sensei.middleware.domains.PropertiesListenerHelper.read (in);
           this.setPropertiesListener (listener);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the properties of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
       case 20:  // sensei/middleware/domains/PropertiesHandler/getAllProperties
       {
         try {
           sensei.middleware.domains.MemberProperties $result[] = null;
           $result = this.getAllProperties ();
           out = $rh.createReply();
           sensei.middleware.domains.MemberPropertiesListHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the property with the given name of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
       case 21:  // sensei/middleware/domains/PropertiesHandler/getPropertyForAllMembers
       {
         try {
           String nam = sensei.middleware.domains.NameHelper.read (in);
           sensei.middleware.domains.MemberProperties $result[] = null;
           $result = this.getPropertyForAllMembers (nam);
           out = $rh.createReply();
           sensei.middleware.domains.MemberPropertiesListHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the properties of the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
       case 22:  // sensei/middleware/domains/PropertiesHandler/getMemberProperties
       {
         try {
           int loc = sensei.middleware.domains.LocationHelper.read (in);
           sensei.middleware.domains.Property $result[] = null;
           $result = this.getMemberProperties (loc);
           out = $rh.createReply();
           sensei.middleware.domains.PropertiesHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the property with the given name for the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
       case 23:  // sensei/middleware/domains/PropertiesHandler/getMemberProperty
       {
         try {
           int loc = sensei.middleware.domains.LocationHelper.read (in);
           String n = sensei.middleware.domains.NameHelper.read (in);
           String $result = null;
           $result = this.getMemberProperty (loc, n);
           out = $rh.createReply();
           out.write_string ($result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the properties of the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
       case 24:  // sensei/middleware/domains/PropertiesHandler/getProperties
       {
         try {
           sensei.middleware.domains.Property $result[] = null;
           $result = this.getProperties ();
           out = $rh.createReply();
           sensei.middleware.domains.PropertiesHelper.write (out, $result);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the property with the given name for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
       case 25:  // sensei/middleware/domains/PropertiesHandler/getProperty
       {
         try {
           String n = sensei.middleware.domains.NameHelper.read (in);
           String $result = null;
           $result = this.getProperty (n);
           out = $rh.createReply();
           out.write_string ($result);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Sets the properties for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
       case 26:  // sensei/middleware/domains/PropertiesHandler/setProperties
       {
         try {
           sensei.middleware.domains.Property props[] = sensei.middleware.domains.PropertiesHelper.read (in);
           this.setProperties (props);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Adds the properties for the member handled by this PropertyHandler. If some property were already
           * existing, its value is overriden.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
       case 27:  // sensei/middleware/domains/PropertiesHandler/addProperties
       {
         try {
           sensei.middleware.domains.Property props[] = sensei.middleware.domains.PropertiesHelper.read (in);
           this.addProperties (props);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Removes the properties for the member handled by this PropertyHandler. If some property were not
           * existing, it is ignored.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
       case 28:  // sensei/middleware/domains/PropertiesHandler/removeProperties
       {
         try {
           sensei.middleware.domains.Property props[] = sensei.middleware.domains.PropertiesHelper.read (in);
           this.removeProperties (props);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Sets a DynamicSubgroupsUser listener. This user must be set before the member joins
           * a group, or an exception is raised
           */
       case 29:  // sensei/middleware/domains/SubgroupsHandler/setDynamicSubgroupsUser
       {
         try {
           sensei.middleware.domains.DynamicSubgroupsUser user = sensei.middleware.domains.DynamicSubgroupsUserHelper.read (in);
           this.setDynamicSubgroupsUser (user);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Registers a static subgroup with a specific ID. This ID must be unique in the object and also
            * in the group. The group cannot have been activated yet, or an exception is raised.
            * Every member must have defined the same subgroups when the group is joined.
            * Once joined, it is not possible anymore to use registerSubgroup, as the subgroups
            * must be dynamically registered.
            * The subgroups registered with this method cannot be later unregistered.
            * The subgroupId must be a valid static subgroup Id (lower or equal to MAX_STATIC_SUBGROUP_ID)
            * or the subgroup is not registered and an exception is raised
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the subgroupId specified is not valid (not static)
            **/
       case 30:  // sensei/middleware/domains/SubgroupsHandler/registerSubgroup
       {
         try {
           int uniqueSubgroupId = sensei.middleware.domains.SubgroupIdHelper.read (in);
           sensei.middleware.gms.GroupMember subgroup = sensei.middleware.domains.GroupMemberHelper.read (in);
           this.registerSubgroup (uniqueSubgroupId, subgroup);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SubgroupsHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SubgroupsHandlerExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
       case 31:  // sensei/middleware/domains/SubgroupsHandler/castSubgroupCreation
       {
         try {
           sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
           this.castSubgroupCreation (info);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SubgroupsHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SubgroupsHandlerExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * this call blocks until the subgroup is registered, returning the created subgroupId
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
       case 32:  // sensei/middleware/domains/SubgroupsHandler/createSubgroup
       {
         try {
           sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
           sensei.middleware.gms.GroupMember subgroup = sensei.middleware.domains.GroupMemberHelper.read (in);
           int $result = (int)0;
           $result = this.createSubgroup (info, subgroup);
           out = $rh.createReply();
           out.write_long ($result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SubgroupsHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SubgroupsHandlerExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Removes the given subgroup. Only dynamic subgroups can be removed.
            * If the group is static, an exception is raised. If the subgroup does not exist, false is returned
            * Every member in the group receives a removedSubgroup notification
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups or the
            *       subgroupId given is describes a static subgroup
            */
       case 33:  // sensei/middleware/domains/SubgroupsHandler/removeSubgroup
       {
         try {
           int id = sensei.middleware.domains.SubgroupIdHelper.read (in);
           sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
           boolean $result = false;
           $result = this.removeSubgroup (id, info);
           out = $rh.createReply();
           out.write_boolean ($result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SubgroupsHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SubgroupsHandlerExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Returns the existing groups, statics and dynamics
            */
       case 34:  // sensei/middleware/domains/SubgroupsHandler/getSubgroups
       {
         int $result[] = null;
         $result = this.getSubgroups ();
         out = $rh.createReply();
         sensei.middleware.domains.SubgroupIdsListHelper.write (out, $result);
         break;
       }


  /**
            * Returns the subgroup associated to a given subgroupId, null if not existing
            */
       case 35:  // sensei/middleware/domains/SubgroupsHandler/getSubgroup
       {
         int id = sensei.middleware.domains.SubgroupIdHelper.read (in);
         sensei.middleware.gms.GroupMember $result = null;
         $result = this.getSubgroup (id);
         out = $rh.createReply();
         sensei.middleware.gms.GroupMemberHelper.write (out, $result);
         break;
       }


  /**
            * Returns the subgroupId for a group. If the group is not valid, EVERY_SUBGROUP is returned
            */
       case 36:  // sensei/middleware/domains/SubgroupsHandler/getSubgroupId
       {
         sensei.middleware.gms.GroupMember subgroup = sensei.middleware.domains.GroupMemberHelper.read (in);
         int $result = (int)0;
         $result = this.getSubgroupId (subgroup);
         out = $rh.createReply();
         out.write_long ($result);
         break;
       }


  /**
           * Starts a transaction, locking first the given monitor.
           * Transactions can be nested, but nested transactions only end when the initial transaction
           * is finished.
           * A system on a transaction does not start any state transfer, and all the messages
           * sent by the group handler are queued until the transaction ends. As the result, messages
           * can be seen by other members in different views, and this interface is therefore only
           * allowed under mode MembersOnTransferExcludedFromGroup.
           * @exception MonitorException if the monitor is not valid
           * @exception TransactionException if transactions are not allowed
           */
       case 37:  // sensei/middleware/domains/TransactionsHandler/startTransaction
       {
         try {
           sensei.middleware.domains.Monitor locker = sensei.middleware.domains.MonitorHelper.read (in);
           this.startTransaction (locker);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MonitorException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MonitorExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.TransactionException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.TransactionExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Ends a transaction, unlocking the given monitor. The operation only takes place, in case
           * of nested transactions, when the initial transaction ends.
           * @exception MonitorException if the monitor used for the transaction has been unlocked inside
           *            the transaction
           * @exception TransactionException if transactions are not allowed, or there is not any current transaction
           */
       case 38:  // sensei/middleware/domains/TransactionsHandler/endTransaction
       {
         try {
           this.endTransaction ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MonitorException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MonitorExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.TransactionException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.TransactionExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/DomainGroupHandler:1.0", 
    "IDL:sensei/middleware/gms/GroupHandler:1.0", 
    "IDL:sensei/middleware/gms/GroupMember:1.0", 
    "IDL:sensei/middleware/domains/PropertiesHandler:1.0", 
    "IDL:sensei/middleware/domains/SubgroupsHandler:1.0", 
    "IDL:sensei/middleware/domains/TransactionsHandler:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public DomainGroupHandler _this() 
  {
    return DomainGroupHandlerHelper.narrow(
    super._this_object());
  }

  public DomainGroupHandler _this(org.omg.CORBA.ORB orb) 
  {
    return DomainGroupHandlerHelper.narrow(
    super._this_object(orb));
  }


} // class DomainGroupHandlerPOA
