package sensei.middleware.domains;


/**
* sensei/middleware/domains/DomainGroupHandlerPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
        * GroupMember targetted as central instance to handle several subgroups
        * Messages sent through this class must belong to the DomainMessage hierarchy
        *
        *   -	It allows to define several subgroups to be handled separately by one group.
        *   - The subgroups can be created/removed dynamically.
        *   -	It includes the abstraction group/subgroups or domain/groups
        * It supports several special features:
        * -The sending of messages blocks the caller until the message is received
        * -Reception of cast messages sent by the own member are not propagated to the
        *    subgroups: they just unblock the message sending.
        * -PTP messages can be sent to all the subgroups in the group
        * -State transfer support
        * -Replica properties support
        * -Transactions support
        **/
public class DomainGroupHandlerPOATie extends DomainGroupHandlerPOA
{

  // Constructors

  public DomainGroupHandlerPOATie ( sensei.middleware.domains.DomainGroupHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public DomainGroupHandlerPOATie ( sensei.middleware.domains.DomainGroupHandlerOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.domains.DomainGroupHandlerOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.domains.DomainGroupHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
           * Sets the mode under view changes. It can only be set before the domain Group Handler joins a group,
           * or an exception is thrown
           */
  public void setBehaviourMode (sensei.middleware.domains.BehaviourOnViewChanges mode) throws sensei.middleware.domains.MemberStateException
  {
    _impl.setBehaviourMode(mode);
  } // setBehaviourMode


  /**
           * Sets a coordinator elector. It must be set before the DomainGroupHandler joins a group, or an
           * exception is raised
           */
  public void setCoordinatorElector (sensei.middleware.domains.CoordinatorElector elector) throws sensei.middleware.domains.MemberStateException
  {
    _impl.setCoordinatorElector(elector);
  } // setCoordinatorElector


  /**
           * Sets a listener to DomainGroup events. It must be set before the DomainGroupHandler joins a group, or an
           * exception is raised
           */
  public void setDomainGroupUser (sensei.middleware.domains.DomainGroupUser user) throws sensei.middleware.domains.MemberStateException
  {
    _impl.setDomainGroupUser(user);
  } // setDomainGroupUser


  /**
           * Returns the list of stateful members. This operation can only be invoked on stateful members,
           * or an exception is thrown
           */
  public int[] getStatefulMembers () throws sensei.middleware.domains.MemberStateException
  {
    return _impl.getStatefulMembers();
  } // getStatefulMembers


  /**
            * Cast a message to the subgroup, and blocks until it is processed.
            * @param normalProcessing set to true if the message is to be received through the normal
            *        processCastMessage. In that case, this call blocks until the message is processed.
            *        If it is false, the call blocks until the caller can process the operation, and
            *        when it finishes, it must call to syncCastDomainMessageProcessed
            **/
  public boolean syncCastDomainMessage (sensei.middleware.domains.DomainMessage message, boolean normalProcessing) throws sensei.middleware.domains.MemberStateException
  {
    return _impl.syncCastDomainMessage(message, normalProcessing);
  } // syncCastDomainMessage


  /**
            * Confirms that a message has been processed. Failing to call to this method after
            *   requesting syncCastDomainMessage with normalProcessing equal to false will avoid the
            *   normal flow of messages into the application, excluding eventually the member from the group
            **/
  public void syncCastDomainMessageProcessed () throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SyncCastDomainMessageProcessedException
  {
    _impl.syncCastDomainMessageProcessed();
  } // syncCastDomainMessageProcessed


  /**
            * Returns the GroupMemberId handled by this GroupHandler
            * If the member is not active, the returned value is random - negative.
            **/
  public int getGroupMemberId ()
  {
    return _impl.getGroupMemberId();
  } // getGroupMemberId


  /**
            * Returns true if the member belong to a group
            **/
  public boolean isValidGroup ()
  {
    return _impl.isValidGroup();
  } // isValidGroup


  /**
            * Leaves the group
            * @returns true if the member was belonging to a group
            **/
  public boolean leaveGroup ()
  {
    return _impl.leaveGroup();
  } // leaveGroup


  /**
            * Sends a message to every member in the view, returning
            * true if the message is sent on this view
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  public boolean castMessage (sensei.middleware.gms.Message msg)
  {
    return _impl.castMessage(msg);
  } // castMessage


  /**
            * Sends a message to the specified member in the view, returning
            * true if the message is sent on this view. This call allows
            * to keep the order between cast and point-to-point messages
            * @param target The member receiving the message
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  public boolean sendMessage (int target, sensei.middleware.gms.Message msg)
  {
    return _impl.sendMessage(target, msg);
  } // sendMessage


  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
  public void processPTPMessage (int sender, sensei.middleware.gms.Message msg)
  {
    _impl.processPTPMessage(sender, msg);
  } // processPTPMessage


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
  public void processCastMessage (int sender, sensei.middleware.gms.Message msg)
  {
    _impl.processCastMessage(sender, msg);
  } // processCastMessage


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
  public void memberAccepted (int identity, sensei.middleware.gms.GroupHandler handler, sensei.middleware.gms.View theView)
  {
    _impl.memberAccepted(identity, handler, theView);
  } // memberAccepted


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
  public void changingView ()
  {
    _impl.changingView();
  } // changingView


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
  public void installView (sensei.middleware.gms.View theView)
  {
    _impl.installView(theView);
  } // installView


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
  public void excludedFromGroup ()
  {
    _impl.excludedFromGroup();
  } // excludedFromGroup


  /**
           * Enables the use of properties, which is disabled by default.
           * This method must be invoked before the member joins the group, or an exception is raised.
           * Every member in the group must use the same properties
           * policy.
           */
  public void enableProperties () throws sensei.middleware.domains.MemberStateException
  {
    _impl.enableProperties();
  } // enableProperties


  /**
           * Returns the properties policy
           */
  public boolean arePropertiesEnabled ()
  {
    return _impl.arePropertiesEnabled();
  } // arePropertiesEnabled


  /**
           * Sets a PropertiesListener, that will receive the properties update notifications. The user
           * can be set at any moment, and if a nil user is specified, no user will be used.
           */
  public void setPropertiesListener (sensei.middleware.domains.PropertiesListener listener) throws sensei.middleware.domains.PropertiesDisabledException
  {
    _impl.setPropertiesListener(listener);
  } // setPropertiesListener


  /**
           * Returns the properties of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.MemberProperties[] getAllProperties () throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getAllProperties();
  } // getAllProperties


  /**
           * Returns the property with the given name of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.MemberProperties[] getPropertyForAllMembers (String nam) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getPropertyForAllMembers(nam);
  } // getPropertyForAllMembers


  /**
           * Returns the properties of the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.Property[] getMemberProperties (int loc) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getMemberProperties(loc);
  } // getMemberProperties


  /**
           * Returns the property with the given name for the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public String getMemberProperty (int loc, String n) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getMemberProperty(loc, n);
  } // getMemberProperty


  /**
           * Returns the properties of the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
  public sensei.middleware.domains.Property[] getProperties () throws sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getProperties();
  } // getProperties


  /**
           * Returns the property with the given name for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
  public String getProperty (String n) throws sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getProperty(n);
  } // getProperty


  /**
           * Sets the properties for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void setProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    _impl.setProperties(props);
  } // setProperties


  /**
           * Adds the properties for the member handled by this PropertyHandler. If some property were already
           * existing, its value is overriden.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void addProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    _impl.addProperties(props);
  } // addProperties


  /**
           * Removes the properties for the member handled by this PropertyHandler. If some property were not
           * existing, it is ignored.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void removeProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    _impl.removeProperties(props);
  } // removeProperties


  /**
           * Sets a DynamicSubgroupsUser listener. This user must be set before the member joins
           * a group, or an exception is raised
           */
  public void setDynamicSubgroupsUser (sensei.middleware.domains.DynamicSubgroupsUser user) throws sensei.middleware.domains.MemberStateException
  {
    _impl.setDynamicSubgroupsUser(user);
  } // setDynamicSubgroupsUser


  /**
            * Registers a static subgroup with a specific ID. This ID must be unique in the object and also
            * in the group. The group cannot have been activated yet, or an exception is raised.
            * Every member must have defined the same subgroups when the group is joined.
            * Once joined, it is not possible anymore to use registerSubgroup, as the subgroups
            * must be dynamically registered.
            * The subgroups registered with this method cannot be later unregistered.
            * The subgroupId must be a valid static subgroup Id (lower or equal to MAX_STATIC_SUBGROUP_ID)
            * or the subgroup is not registered and an exception is raised
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the subgroupId specified is not valid (not static)
            **/
  public void registerSubgroup (int uniqueSubgroupId, sensei.middleware.gms.GroupMember subgroup) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
    _impl.registerSubgroup(uniqueSubgroupId, subgroup);
  } // registerSubgroup


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
  public void castSubgroupCreation (sensei.middleware.domains.DynamicSubgroupInfo info) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
    _impl.castSubgroupCreation(info);
  } // castSubgroupCreation


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * this call blocks until the subgroup is registered, returning the created subgroupId
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
  public int createSubgroup (sensei.middleware.domains.DynamicSubgroupInfo info, sensei.middleware.gms.GroupMember subgroup) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
    return _impl.createSubgroup(info, subgroup);
  } // createSubgroup


  /**
            * Removes the given subgroup. Only dynamic subgroups can be removed.
            * If the group is static, an exception is raised. If the subgroup does not exist, false is returned
            * Every member in the group receives a removedSubgroup notification
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups or the
            *       subgroupId given is describes a static subgroup
            */
  public boolean removeSubgroup (int id, sensei.middleware.domains.DynamicSubgroupInfo info) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
    return _impl.removeSubgroup(id, info);
  } // removeSubgroup


  /**
            * Returns the existing groups, statics and dynamics
            */
  public int[] getSubgroups ()
  {
    return _impl.getSubgroups();
  } // getSubgroups


  /**
            * Returns the subgroup associated to a given subgroupId, null if not existing
            */
  public sensei.middleware.gms.GroupMember getSubgroup (int id)
  {
    return _impl.getSubgroup(id);
  } // getSubgroup


  /**
            * Returns the subgroupId for a group. If the group is not valid, EVERY_SUBGROUP is returned
            */
  public int getSubgroupId (sensei.middleware.gms.GroupMember subgroup)
  {
    return _impl.getSubgroupId(subgroup);
  } // getSubgroupId


  /**
           * Starts a transaction, locking first the given monitor.
           * Transactions can be nested, but nested transactions only end when the initial transaction
           * is finished.
           * A system on a transaction does not start any state transfer, and all the messages
           * sent by the group handler are queued until the transaction ends. As the result, messages
           * can be seen by other members in different views, and this interface is therefore only
           * allowed under mode MembersOnTransferExcludedFromGroup.
           * @exception MonitorException if the monitor is not valid
           * @exception TransactionException if transactions are not allowed
           */
  public void startTransaction (sensei.middleware.domains.Monitor locker) throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException
  {
    _impl.startTransaction(locker);
  } // startTransaction


  /**
           * Ends a transaction, unlocking the given monitor. The operation only takes place, in case
           * of nested transactions, when the initial transaction ends.
           * @exception MonitorException if the monitor used for the transaction has been unlocked inside
           *            the transaction
           * @exception TransactionException if transactions are not allowed, or there is not any current transaction
           */
  public void endTransaction () throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException
  {
    _impl.endTransaction();
  } // endTransaction

  private sensei.middleware.domains.DomainGroupHandlerOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class DomainGroupHandlerPOATie
