package sensei.middleware.domains;


/**
* sensei/middleware/domains/DomainGroupUserOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
       * Interface to be implemented optionally by members using domains
       */
public interface DomainGroupUserOperations 
{

  /**
           * Invoked when the DomainGroup is accepted into its subgroup
           */
  void domainAccepted (int id);

  /**
           * Invoked when the DomainGroup is expulsed from its subgroup
           */
  void domainExpulsed (sensei.middleware.domains.DomainExpulsionReason reason);

  /**
           * Invoked when the DomainGroup is considered to have state
           * @param assumed set to true if this member is assuming state, i.e, is not transfered
           */
  void stateObtained (boolean assumed);

  /**
           * Invoked when the a subgroup in the domain is not reachable. This
           * call will be followed by a domainExpulsed call eventually.
           * @param subgroupId the identity of the subgroup causing the problem
           * @param reason an string explaining the problem
           */
  void offendingSubgroup (int subgroup, String reason);
} // interface DomainGroupUserOperations
