package sensei.middleware.domains;


/**
* sensei/middleware/domains/GroupMonitorPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/***********************************************************************/
public abstract class GroupMonitorPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.GroupMonitorOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("lock", new java.lang.Integer (0));
    _methods.put ("unlock", new java.lang.Integer (1));
    _methods.put ("assumeState", new java.lang.Integer (2));
    _methods.put ("getState", new java.lang.Integer (3));
    _methods.put ("setState", new java.lang.Integer (4));
    _methods.put ("processPTPMessage", new java.lang.Integer (5));
    _methods.put ("processCastMessage", new java.lang.Integer (6));
    _methods.put ("memberAccepted", new java.lang.Integer (7));
    _methods.put ("changingView", new java.lang.Integer (8));
    _methods.put ("installView", new java.lang.Integer (9));
    _methods.put ("excludedFromGroup", new java.lang.Integer (10));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
            * Locks the monitor.
            * This locking is reentrant: the member acquiring it can lock it again.
            * As a consequence, if the member intends to access the monitor from
            * different threads, it will have to include the synchronization
            * by itself
            **/
       case 0:  // sensei/middleware/domains/Monitor/lock
       {
         try {
           this.lock ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Unlocks the monitor;
            * @throws MonitorException if the monitor was not locked by this member
            **/
       case 1:  // sensei/middleware/domains/Monitor/unlock
       {
         try {
           this.unlock ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MonitorException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MonitorExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }

       case 2:  // sensei/middleware/domains/ExtendedCheckpointable/assumeState
       {
         this.assumeState ();
         out = $rh.createReply();
         break;
       }

       case 3:  // sensei/middleware/domains/Checkpointable/getState
       {
         sensei.middleware.domains.State $result = null;
         $result = this.getState ();
         out = $rh.createReply();
         sensei.middleware.domains.StateHelper.write (out, $result);
         break;
       }

       case 4:  // sensei/middleware/domains/Checkpointable/setState
       {
         sensei.middleware.domains.State s = sensei.middleware.domains.StateHelper.read (in);
         this.setState (s);
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
       case 5:  // sensei/middleware/gms/GroupMember/processPTPMessage
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         this.processPTPMessage (sender, msg);
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
       case 6:  // sensei/middleware/gms/GroupMember/processCastMessage
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         this.processCastMessage (sender, msg);
         out = $rh.createReply();
         break;
       }


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
       case 7:  // sensei/middleware/gms/GroupMember/memberAccepted
       {
         int identity = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.GroupHandler handler = sensei.middleware.gms.GroupHandlerHelper.read (in);
         sensei.middleware.gms.View theView = sensei.middleware.gms.ViewHelper.read (in);
         this.memberAccepted (identity, handler, theView);
         out = $rh.createReply();
         break;
       }


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
       case 8:  // sensei/middleware/gms/GroupMember/changingView
       {
         this.changingView ();
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
       case 9:  // sensei/middleware/gms/GroupMember/installView
       {
         sensei.middleware.gms.View theView = sensei.middleware.gms.ViewHelper.read (in);
         this.installView (theView);
         out = $rh.createReply();
         break;
       }


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
       case 10:  // sensei/middleware/gms/GroupMember/excludedFromGroup
       {
         this.excludedFromGroup ();
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/GroupMonitor:1.0", 
    "IDL:sensei/middleware/domains/Monitor:1.0", 
    "IDL:sensei/middleware/domains/ExtendedCheckpointable:1.0", 
    "IDL:sensei/middleware/domains/Checkpointable:1.0", 
    "IDL:sensei/middleware/gms/GroupMember:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public GroupMonitor _this() 
  {
    return GroupMonitorHelper.narrow(
    super._this_object());
  }

  public GroupMonitor _this(org.omg.CORBA.ORB orb) 
  {
    return GroupMonitorHelper.narrow(
    super._this_object(orb));
  }


} // class GroupMonitorPOA
