package sensei.middleware.domains;


/**
* sensei/middleware/domains/MessageP.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
       *  Message p is the initial message sent between DomainGroupHandlers to
       *  transfer their features, and any state transfer information required
       *  (but not the state itself).
       *  It contains:
       *  (a) generic information about the group itself
       *  (b) information about the subgroup layout
       *  (c) list of current statefull members, with their properties and
       *      members being coordinated
       **/
public abstract class MessageP extends sensei.middleware.domains.DomainMessage
{
  public int viewId = (int)0;

 //message can only be processed on the right view
  public sensei.middleware.domains.BehaviourOnViewChanges behaviour = null;
  public boolean coordinatorElectorRegistered = false;
  public boolean dynamicSubgroupsAllowed = false;
  public int nextDynamicSubgroupId = (int)0;
  public sensei.middleware.domains.SubgroupProperties subgroupsInformation[] = null;
  public sensei.middleware.domains.MemberProperties props[] = null;
  public sensei.middleware.domains.ReplicaInformation replicasInfo[] = null;

  private static String[] _truncatable_ids = {
    sensei.middleware.domains.MessagePHelper.id ()
  };

  public String[] _truncatable_ids() {
    return _truncatable_ids;
  }

  public void _read (org.omg.CORBA.portable.InputStream istream)
  {
    super._read (istream);
    this.viewId = istream.read_long ();
    this.behaviour = sensei.middleware.domains.BehaviourOnViewChangesHelper.read (istream);
    this.coordinatorElectorRegistered = istream.read_boolean ();
    this.dynamicSubgroupsAllowed = istream.read_boolean ();
    this.nextDynamicSubgroupId = istream.read_long ();
    this.subgroupsInformation = sensei.middleware.domains.SubgroupsInfoHelper.read (istream);
    this.props = sensei.middleware.domains.MemberPropertiesListHelper.read (istream);
    this.replicasInfo = sensei.middleware.domains.ReplicasInformationHelper.read (istream);
  }

  public void _write (org.omg.CORBA.portable.OutputStream ostream)
  {
    super._write (ostream);
    ostream.write_long (this.viewId);
    sensei.middleware.domains.BehaviourOnViewChangesHelper.write (ostream, this.behaviour);
    ostream.write_boolean (this.coordinatorElectorRegistered);
    ostream.write_boolean (this.dynamicSubgroupsAllowed);
    ostream.write_long (this.nextDynamicSubgroupId);
    sensei.middleware.domains.SubgroupsInfoHelper.write (ostream, this.subgroupsInformation);
    sensei.middleware.domains.MemberPropertiesListHelper.write (ostream, this.props);
    sensei.middleware.domains.ReplicasInformationHelper.write (ostream, this.replicasInfo);
  }

  public org.omg.CORBA.TypeCode _type ()
  {
    return sensei.middleware.domains.MessagePHelper.type ();
  }
} // class MessageP
