package sensei.middleware.domains;


/**
* sensei/middleware/domains/SubgroupsHandlerPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/**
       *  Interface supporting subgroups handling
       **/
public abstract class SubgroupsHandlerPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.SubgroupsHandlerOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("setDynamicSubgroupsUser", new java.lang.Integer (0));
    _methods.put ("registerSubgroup", new java.lang.Integer (1));
    _methods.put ("castSubgroupCreation", new java.lang.Integer (2));
    _methods.put ("createSubgroup", new java.lang.Integer (3));
    _methods.put ("removeSubgroup", new java.lang.Integer (4));
    _methods.put ("getSubgroups", new java.lang.Integer (5));
    _methods.put ("getSubgroup", new java.lang.Integer (6));
    _methods.put ("getSubgroupId", new java.lang.Integer (7));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
           * Sets a DynamicSubgroupsUser listener. This user must be set before the member joins
           * a group, or an exception is raised
           */
       case 0:  // sensei/middleware/domains/SubgroupsHandler/setDynamicSubgroupsUser
       {
         try {
           sensei.middleware.domains.DynamicSubgroupsUser user = sensei.middleware.domains.DynamicSubgroupsUserHelper.read (in);
           this.setDynamicSubgroupsUser (user);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Registers a static subgroup with a specific ID. This ID must be unique in the object and also
            * in the group. The group cannot have been activated yet, or an exception is raised.
            * Every member must have defined the same subgroups when the group is joined.
            * Once joined, it is not possible anymore to use registerSubgroup, as the subgroups
            * must be dynamically registered.
            * The subgroups registered with this method cannot be later unregistered.
            * The subgroupId must be a valid static subgroup Id (lower or equal to MAX_STATIC_SUBGROUP_ID)
            * or the subgroup is not registered and an exception is raised
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the subgroupId specified is not valid (not static)
            **/
       case 1:  // sensei/middleware/domains/SubgroupsHandler/registerSubgroup
       {
         try {
           int uniqueSubgroupId = sensei.middleware.domains.SubgroupIdHelper.read (in);
           sensei.middleware.gms.GroupMember subgroup = sensei.middleware.domains.GroupMemberHelper.read (in);
           this.registerSubgroup (uniqueSubgroupId, subgroup);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SubgroupsHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SubgroupsHandlerExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
       case 2:  // sensei/middleware/domains/SubgroupsHandler/castSubgroupCreation
       {
         try {
           sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
           this.castSubgroupCreation (info);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SubgroupsHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SubgroupsHandlerExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * this call blocks until the subgroup is registered, returning the created subgroupId
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
       case 3:  // sensei/middleware/domains/SubgroupsHandler/createSubgroup
       {
         try {
           sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
           sensei.middleware.gms.GroupMember subgroup = sensei.middleware.domains.GroupMemberHelper.read (in);
           int $result = (int)0;
           $result = this.createSubgroup (info, subgroup);
           out = $rh.createReply();
           out.write_long ($result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SubgroupsHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SubgroupsHandlerExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Removes the given subgroup. Only dynamic subgroups can be removed.
            * If the group is static, an exception is raised. If the subgroup does not exist, false is returned
            * Every member in the group receives a removedSubgroup notification
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups or the
            *       subgroupId given is describes a static subgroup
            */
       case 4:  // sensei/middleware/domains/SubgroupsHandler/removeSubgroup
       {
         try {
           int id = sensei.middleware.domains.SubgroupIdHelper.read (in);
           sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
           boolean $result = false;
           $result = this.removeSubgroup (id, info);
           out = $rh.createReply();
           out.write_boolean ($result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.SubgroupsHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.SubgroupsHandlerExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Returns the existing groups, statics and dynamics
            */
       case 5:  // sensei/middleware/domains/SubgroupsHandler/getSubgroups
       {
         int $result[] = null;
         $result = this.getSubgroups ();
         out = $rh.createReply();
         sensei.middleware.domains.SubgroupIdsListHelper.write (out, $result);
         break;
       }


  /**
            * Returns the subgroup associated to a given subgroupId, null if not existing
            */
       case 6:  // sensei/middleware/domains/SubgroupsHandler/getSubgroup
       {
         int id = sensei.middleware.domains.SubgroupIdHelper.read (in);
         sensei.middleware.gms.GroupMember $result = null;
         $result = this.getSubgroup (id);
         out = $rh.createReply();
         sensei.middleware.gms.GroupMemberHelper.write (out, $result);
         break;
       }


  /**
            * Returns the subgroupId for a group. If the group is not valid, EVERY_SUBGROUP is returned
            */
       case 7:  // sensei/middleware/domains/SubgroupsHandler/getSubgroupId
       {
         sensei.middleware.gms.GroupMember subgroup = sensei.middleware.domains.GroupMemberHelper.read (in);
         int $result = (int)0;
         $result = this.getSubgroupId (subgroup);
         out = $rh.createReply();
         out.write_long ($result);
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/SubgroupsHandler:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public SubgroupsHandler _this() 
  {
    return SubgroupsHandlerHelper.narrow(
    super._this_object());
  }

  public SubgroupsHandler _this(org.omg.CORBA.ORB orb) 
  {
    return SubgroupsHandlerHelper.narrow(
    super._this_object(orb));
  }


} // class SubgroupsHandlerPOA
