package sensei.middleware.domains;


/**
* sensei/middleware/domains/SubgroupsHandlerPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/**
       *  Interface supporting subgroups handling
       **/
public class SubgroupsHandlerPOATie extends SubgroupsHandlerPOA
{

  // Constructors

  public SubgroupsHandlerPOATie ( sensei.middleware.domains.SubgroupsHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public SubgroupsHandlerPOATie ( sensei.middleware.domains.SubgroupsHandlerOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.domains.SubgroupsHandlerOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.domains.SubgroupsHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
           * Sets a DynamicSubgroupsUser listener. This user must be set before the member joins
           * a group, or an exception is raised
           */
  public void setDynamicSubgroupsUser (sensei.middleware.domains.DynamicSubgroupsUser user) throws sensei.middleware.domains.MemberStateException
  {
    _impl.setDynamicSubgroupsUser(user);
  } // setDynamicSubgroupsUser


  /**
            * Registers a static subgroup with a specific ID. This ID must be unique in the object and also
            * in the group. The group cannot have been activated yet, or an exception is raised.
            * Every member must have defined the same subgroups when the group is joined.
            * Once joined, it is not possible anymore to use registerSubgroup, as the subgroups
            * must be dynamically registered.
            * The subgroups registered with this method cannot be later unregistered.
            * The subgroupId must be a valid static subgroup Id (lower or equal to MAX_STATIC_SUBGROUP_ID)
            * or the subgroup is not registered and an exception is raised
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the subgroupId specified is not valid (not static)
            **/
  public void registerSubgroup (int uniqueSubgroupId, sensei.middleware.gms.GroupMember subgroup) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
    _impl.registerSubgroup(uniqueSubgroupId, subgroup);
  } // registerSubgroup


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
  public void castSubgroupCreation (sensei.middleware.domains.DynamicSubgroupInfo info) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
    _impl.castSubgroupCreation(info);
  } // castSubgroupCreation


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * this call blocks until the subgroup is registered, returning the created subgroupId
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
  public int createSubgroup (sensei.middleware.domains.DynamicSubgroupInfo info, sensei.middleware.gms.GroupMember subgroup) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
    return _impl.createSubgroup(info, subgroup);
  } // createSubgroup


  /**
            * Removes the given subgroup. Only dynamic subgroups can be removed.
            * If the group is static, an exception is raised. If the subgroup does not exist, false is returned
            * Every member in the group receives a removedSubgroup notification
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups or the
            *       subgroupId given is describes a static subgroup
            */
  public boolean removeSubgroup (int id, sensei.middleware.domains.DynamicSubgroupInfo info) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
    return _impl.removeSubgroup(id, info);
  } // removeSubgroup


  /**
            * Returns the existing groups, statics and dynamics
            */
  public int[] getSubgroups ()
  {
    return _impl.getSubgroups();
  } // getSubgroups


  /**
            * Returns the subgroup associated to a given subgroupId, null if not existing
            */
  public sensei.middleware.gms.GroupMember getSubgroup (int id)
  {
    return _impl.getSubgroup(id);
  } // getSubgroup


  /**
            * Returns the subgroupId for a group. If the group is not valid, EVERY_SUBGROUP is returned
            */
  public int getSubgroupId (sensei.middleware.gms.GroupMember subgroup)
  {
    return _impl.getSubgroupId(subgroup);
  } // getSubgroupId

  private sensei.middleware.domains.SubgroupsHandlerOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class SubgroupsHandlerPOATie
