package sensei.middleware.domains;


/**
* sensei/middleware/domains/TransactionsHandlerOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/

public interface TransactionsHandlerOperations 
{

  /**
           * Starts a transaction, locking first the given monitor.
           * Transactions can be nested, but nested transactions only end when the initial transaction
           * is finished.
           * A system on a transaction does not start any state transfer, and all the messages
           * sent by the group handler are queued until the transaction ends. As the result, messages
           * can be seen by other members in different views, and this interface is therefore only
           * allowed under mode MembersOnTransferExcludedFromGroup.
           * @exception MonitorException if the monitor is not valid
           * @exception TransactionException if transactions are not allowed
           */
  void startTransaction (sensei.middleware.domains.Monitor locker) throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException;

  /**
           * Ends a transaction, unlocking the given monitor. The operation only takes place, in case
           * of nested transactions, when the initial transaction ends.
           * @exception MonitorException if the monitor used for the transaction has been unlocked inside
           *            the transaction
           * @exception TransactionException if transactions are not allowed, or there is not any current transaction
           */
  void endTransaction () throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException;
} // interface TransactionsHandlerOperations
