package sensei.middleware.domains;


/**
* sensei/middleware/domains/_DomainGroupHandlerStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
        * GroupMember targetted as central instance to handle several subgroups
        * Messages sent through this class must belong to the DomainMessage hierarchy
        *
        *   -	It allows to define several subgroups to be handled separately by one group.
        *   - The subgroups can be created/removed dynamically.
        *   -	It includes the abstraction group/subgroups or domain/groups
        * It supports several special features:
        * -The sending of messages blocks the caller until the message is received
        * -Reception of cast messages sent by the own member are not propagated to the
        *    subgroups: they just unblock the message sending.
        * -PTP messages can be sent to all the subgroups in the group
        * -State transfer support
        * -Replica properties support
        * -Transactions support
        **/
public class _DomainGroupHandlerStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.domains.DomainGroupHandler
{


  /**
           * Sets the mode under view changes. It can only be set before the domain Group Handler joins a group,
           * or an exception is thrown
           */
  public void setBehaviourMode (sensei.middleware.domains.BehaviourOnViewChanges mode) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setBehaviourMode", true);
                sensei.middleware.domains.BehaviourOnViewChangesHelper.write ($out, mode);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setBehaviourMode (mode        );
            } finally {
                _releaseReply ($in);
            }
  } // setBehaviourMode


  /**
           * Sets a coordinator elector. It must be set before the DomainGroupHandler joins a group, or an
           * exception is raised
           */
  public void setCoordinatorElector (sensei.middleware.domains.CoordinatorElector elector) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setCoordinatorElector", true);
                sensei.middleware.domains.CoordinatorElectorHelper.write ($out, elector);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setCoordinatorElector (elector        );
            } finally {
                _releaseReply ($in);
            }
  } // setCoordinatorElector


  /**
           * Sets a listener to DomainGroup events. It must be set before the DomainGroupHandler joins a group, or an
           * exception is raised
           */
  public void setDomainGroupUser (sensei.middleware.domains.DomainGroupUser user) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setDomainGroupUser", true);
                sensei.middleware.domains.DomainGroupUserHelper.write ($out, user);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setDomainGroupUser (user        );
            } finally {
                _releaseReply ($in);
            }
  } // setDomainGroupUser


  /**
           * Returns the list of stateful members. This operation can only be invoked on stateful members,
           * or an exception is thrown
           */
  public int[] getStatefulMembers () throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getStatefulMembers", true);
                $in = _invoke ($out);
                int $result[] = sensei.middleware.domains.GroupMemberIdListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getStatefulMembers (        );
            } finally {
                _releaseReply ($in);
            }
  } // getStatefulMembers


  /**
            * Cast a message to the subgroup, and blocks until it is processed.
            * @param normalProcessing set to true if the message is to be received through the normal
            *        processCastMessage. In that case, this call blocks until the message is processed.
            *        If it is false, the call blocks until the caller can process the operation, and
            *        when it finishes, it must call to syncCastDomainMessageProcessed
            **/
  public boolean syncCastDomainMessage (sensei.middleware.domains.DomainMessage message, boolean normalProcessing) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("syncCastDomainMessage", true);
                sensei.middleware.domains.DomainMessageHelper.write ($out, message);
                $out.write_boolean (normalProcessing);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return syncCastDomainMessage (message, normalProcessing        );
            } finally {
                _releaseReply ($in);
            }
  } // syncCastDomainMessage


  /**
            * Confirms that a message has been processed. Failing to call to this method after
            *   requesting syncCastDomainMessage with normalProcessing equal to false will avoid the
            *   normal flow of messages into the application, excluding eventually the member from the group
            **/
  public void syncCastDomainMessageProcessed () throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SyncCastDomainMessageProcessedException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("syncCastDomainMessageProcessed", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SyncCastDomainMessageProcessedException:1.0"))
                    throw sensei.middleware.domains.SyncCastDomainMessageProcessedExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                syncCastDomainMessageProcessed (        );
            } finally {
                _releaseReply ($in);
            }
  } // syncCastDomainMessageProcessed


  /**
            * Returns the GroupMemberId handled by this GroupHandler
            * If the member is not active, the returned value is random - negative.
            **/
  public int getGroupMemberId ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getGroupMemberId", true);
                $in = _invoke ($out);
                int $result = sensei.middleware.gms.GroupMemberIdHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getGroupMemberId (        );
            } finally {
                _releaseReply ($in);
            }
  } // getGroupMemberId


  /**
            * Returns true if the member belong to a group
            **/
  public boolean isValidGroup ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("isValidGroup", true);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return isValidGroup (        );
            } finally {
                _releaseReply ($in);
            }
  } // isValidGroup


  /**
            * Leaves the group
            * @returns true if the member was belonging to a group
            **/
  public boolean leaveGroup ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("leaveGroup", true);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return leaveGroup (        );
            } finally {
                _releaseReply ($in);
            }
  } // leaveGroup


  /**
            * Sends a message to every member in the view, returning
            * true if the message is sent on this view
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  public boolean castMessage (sensei.middleware.gms.Message msg)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("castMessage", true);
                sensei.middleware.gms.MessageHelper.write ($out, msg);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return castMessage (msg        );
            } finally {
                _releaseReply ($in);
            }
  } // castMessage


  /**
            * Sends a message to the specified member in the view, returning
            * true if the message is sent on this view. This call allows
            * to keep the order between cast and point-to-point messages
            * @param target The member receiving the message
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  public boolean sendMessage (int target, sensei.middleware.gms.Message msg)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("sendMessage", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, target);
                sensei.middleware.gms.MessageHelper.write ($out, msg);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return sendMessage (target, msg        );
            } finally {
                _releaseReply ($in);
            }
  } // sendMessage


  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
  public void processPTPMessage (int sender, sensei.middleware.gms.Message msg)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("processPTPMessage", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.MessageHelper.write ($out, msg);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                processPTPMessage (sender, msg        );
            } finally {
                _releaseReply ($in);
            }
  } // processPTPMessage


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
  public void processCastMessage (int sender, sensei.middleware.gms.Message msg)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("processCastMessage", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.MessageHelper.write ($out, msg);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                processCastMessage (sender, msg        );
            } finally {
                _releaseReply ($in);
            }
  } // processCastMessage


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
  public void memberAccepted (int identity, sensei.middleware.gms.GroupHandler handler, sensei.middleware.gms.View theView)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("memberAccepted", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, identity);
                sensei.middleware.gms.GroupHandlerHelper.write ($out, handler);
                sensei.middleware.gms.ViewHelper.write ($out, theView);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                memberAccepted (identity, handler, theView        );
            } finally {
                _releaseReply ($in);
            }
  } // memberAccepted


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
  public void changingView ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("changingView", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                changingView (        );
            } finally {
                _releaseReply ($in);
            }
  } // changingView


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
  public void installView (sensei.middleware.gms.View theView)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("installView", true);
                sensei.middleware.gms.ViewHelper.write ($out, theView);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                installView (theView        );
            } finally {
                _releaseReply ($in);
            }
  } // installView


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
  public void excludedFromGroup ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("excludedFromGroup", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                excludedFromGroup (        );
            } finally {
                _releaseReply ($in);
            }
  } // excludedFromGroup


  /**
           * Enables the use of properties, which is disabled by default.
           * This method must be invoked before the member joins the group, or an exception is raised.
           * Every member in the group must use the same properties
           * policy.
           */
  public void enableProperties () throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("enableProperties", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                enableProperties (        );
            } finally {
                _releaseReply ($in);
            }
  } // enableProperties


  /**
           * Returns the properties policy
           */
  public boolean arePropertiesEnabled ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("arePropertiesEnabled", true);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return arePropertiesEnabled (        );
            } finally {
                _releaseReply ($in);
            }
  } // arePropertiesEnabled


  /**
           * Sets a PropertiesListener, that will receive the properties update notifications. The user
           * can be set at any moment, and if a nil user is specified, no user will be used.
           */
  public void setPropertiesListener (sensei.middleware.domains.PropertiesListener listener) throws sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setPropertiesListener", true);
                sensei.middleware.domains.PropertiesListenerHelper.write ($out, listener);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setPropertiesListener (listener        );
            } finally {
                _releaseReply ($in);
            }
  } // setPropertiesListener


  /**
           * Returns the properties of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.MemberProperties[] getAllProperties () throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getAllProperties", true);
                $in = _invoke ($out);
                sensei.middleware.domains.MemberProperties $result[] = sensei.middleware.domains.MemberPropertiesListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getAllProperties (        );
            } finally {
                _releaseReply ($in);
            }
  } // getAllProperties


  /**
           * Returns the property with the given name of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.MemberProperties[] getPropertyForAllMembers (String nam) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getPropertyForAllMembers", true);
                sensei.middleware.domains.NameHelper.write ($out, nam);
                $in = _invoke ($out);
                sensei.middleware.domains.MemberProperties $result[] = sensei.middleware.domains.MemberPropertiesListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getPropertyForAllMembers (nam        );
            } finally {
                _releaseReply ($in);
            }
  } // getPropertyForAllMembers


  /**
           * Returns the properties of the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.Property[] getMemberProperties (int loc) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getMemberProperties", true);
                sensei.middleware.domains.LocationHelper.write ($out, loc);
                $in = _invoke ($out);
                sensei.middleware.domains.Property $result[] = sensei.middleware.domains.PropertiesHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getMemberProperties (loc        );
            } finally {
                _releaseReply ($in);
            }
  } // getMemberProperties


  /**
           * Returns the property with the given name for the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public String getMemberProperty (int loc, String n) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getMemberProperty", true);
                sensei.middleware.domains.LocationHelper.write ($out, loc);
                sensei.middleware.domains.NameHelper.write ($out, n);
                $in = _invoke ($out);
                String $result = sensei.middleware.domains.ValueHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getMemberProperty (loc, n        );
            } finally {
                _releaseReply ($in);
            }
  } // getMemberProperty


  /**
           * Returns the properties of the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
  public sensei.middleware.domains.Property[] getProperties () throws sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getProperties", true);
                $in = _invoke ($out);
                sensei.middleware.domains.Property $result[] = sensei.middleware.domains.PropertiesHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getProperties (        );
            } finally {
                _releaseReply ($in);
            }
  } // getProperties


  /**
           * Returns the property with the given name for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
  public String getProperty (String n) throws sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getProperty", true);
                sensei.middleware.domains.NameHelper.write ($out, n);
                $in = _invoke ($out);
                String $result = sensei.middleware.domains.ValueHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getProperty (n        );
            } finally {
                _releaseReply ($in);
            }
  } // getProperty


  /**
           * Sets the properties for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void setProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setProperties", true);
                sensei.middleware.domains.PropertiesHelper.write ($out, props);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setProperties (props        );
            } finally {
                _releaseReply ($in);
            }
  } // setProperties


  /**
           * Adds the properties for the member handled by this PropertyHandler. If some property were already
           * existing, its value is overriden.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void addProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("addProperties", true);
                sensei.middleware.domains.PropertiesHelper.write ($out, props);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                addProperties (props        );
            } finally {
                _releaseReply ($in);
            }
  } // addProperties


  /**
           * Removes the properties for the member handled by this PropertyHandler. If some property were not
           * existing, it is ignored.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void removeProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("removeProperties", true);
                sensei.middleware.domains.PropertiesHelper.write ($out, props);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                removeProperties (props        );
            } finally {
                _releaseReply ($in);
            }
  } // removeProperties


  /**
           * Sets a DynamicSubgroupsUser listener. This user must be set before the member joins
           * a group, or an exception is raised
           */
  public void setDynamicSubgroupsUser (sensei.middleware.domains.DynamicSubgroupsUser user) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setDynamicSubgroupsUser", true);
                sensei.middleware.domains.DynamicSubgroupsUserHelper.write ($out, user);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setDynamicSubgroupsUser (user        );
            } finally {
                _releaseReply ($in);
            }
  } // setDynamicSubgroupsUser


  /**
            * Registers a static subgroup with a specific ID. This ID must be unique in the object and also
            * in the group. The group cannot have been activated yet, or an exception is raised.
            * Every member must have defined the same subgroups when the group is joined.
            * Once joined, it is not possible anymore to use registerSubgroup, as the subgroups
            * must be dynamically registered.
            * The subgroups registered with this method cannot be later unregistered.
            * The subgroupId must be a valid static subgroup Id (lower or equal to MAX_STATIC_SUBGROUP_ID)
            * or the subgroup is not registered and an exception is raised
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the subgroupId specified is not valid (not static)
            **/
  public void registerSubgroup (int uniqueSubgroupId, sensei.middleware.gms.GroupMember subgroup) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("registerSubgroup", true);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, uniqueSubgroupId);
                sensei.middleware.domains.GroupMemberHelper.write ($out, subgroup);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SubgroupsHandlerException:1.0"))
                    throw sensei.middleware.domains.SubgroupsHandlerExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                registerSubgroup (uniqueSubgroupId, subgroup        );
            } finally {
                _releaseReply ($in);
            }
  } // registerSubgroup


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
  public void castSubgroupCreation (sensei.middleware.domains.DynamicSubgroupInfo info) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("castSubgroupCreation", true);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SubgroupsHandlerException:1.0"))
                    throw sensei.middleware.domains.SubgroupsHandlerExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                castSubgroupCreation (info        );
            } finally {
                _releaseReply ($in);
            }
  } // castSubgroupCreation


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * this call blocks until the subgroup is registered, returning the created subgroupId
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
  public int createSubgroup (sensei.middleware.domains.DynamicSubgroupInfo info, sensei.middleware.gms.GroupMember subgroup) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("createSubgroup", true);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                sensei.middleware.domains.GroupMemberHelper.write ($out, subgroup);
                $in = _invoke ($out);
                int $result = sensei.middleware.domains.SubgroupIdHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SubgroupsHandlerException:1.0"))
                    throw sensei.middleware.domains.SubgroupsHandlerExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return createSubgroup (info, subgroup        );
            } finally {
                _releaseReply ($in);
            }
  } // createSubgroup


  /**
            * Removes the given subgroup. Only dynamic subgroups can be removed.
            * If the group is static, an exception is raised. If the subgroup does not exist, false is returned
            * Every member in the group receives a removedSubgroup notification
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups or the
            *       subgroupId given is describes a static subgroup
            */
  public boolean removeSubgroup (int id, sensei.middleware.domains.DynamicSubgroupInfo info) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("removeSubgroup", true);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, id);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SubgroupsHandlerException:1.0"))
                    throw sensei.middleware.domains.SubgroupsHandlerExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return removeSubgroup (id, info        );
            } finally {
                _releaseReply ($in);
            }
  } // removeSubgroup


  /**
            * Returns the existing groups, statics and dynamics
            */
  public int[] getSubgroups ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getSubgroups", true);
                $in = _invoke ($out);
                int $result[] = sensei.middleware.domains.SubgroupIdsListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getSubgroups (        );
            } finally {
                _releaseReply ($in);
            }
  } // getSubgroups


  /**
            * Returns the subgroup associated to a given subgroupId, null if not existing
            */
  public sensei.middleware.gms.GroupMember getSubgroup (int id)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getSubgroup", true);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, id);
                $in = _invoke ($out);
                sensei.middleware.gms.GroupMember $result = sensei.middleware.domains.GroupMemberHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getSubgroup (id        );
            } finally {
                _releaseReply ($in);
            }
  } // getSubgroup


  /**
            * Returns the subgroupId for a group. If the group is not valid, EVERY_SUBGROUP is returned
            */
  public int getSubgroupId (sensei.middleware.gms.GroupMember subgroup)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getSubgroupId", true);
                sensei.middleware.domains.GroupMemberHelper.write ($out, subgroup);
                $in = _invoke ($out);
                int $result = sensei.middleware.domains.SubgroupIdHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getSubgroupId (subgroup        );
            } finally {
                _releaseReply ($in);
            }
  } // getSubgroupId


  /**
           * Starts a transaction, locking first the given monitor.
           * Transactions can be nested, but nested transactions only end when the initial transaction
           * is finished.
           * A system on a transaction does not start any state transfer, and all the messages
           * sent by the group handler are queued until the transaction ends. As the result, messages
           * can be seen by other members in different views, and this interface is therefore only
           * allowed under mode MembersOnTransferExcludedFromGroup.
           * @exception MonitorException if the monitor is not valid
           * @exception TransactionException if transactions are not allowed
           */
  public void startTransaction (sensei.middleware.domains.Monitor locker) throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("startTransaction", true);
                sensei.middleware.domains.MonitorHelper.write ($out, locker);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MonitorException:1.0"))
                    throw sensei.middleware.domains.MonitorExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/TransactionException:1.0"))
                    throw sensei.middleware.domains.TransactionExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                startTransaction (locker        );
            } finally {
                _releaseReply ($in);
            }
  } // startTransaction


  /**
           * Ends a transaction, unlocking the given monitor. The operation only takes place, in case
           * of nested transactions, when the initial transaction ends.
           * @exception MonitorException if the monitor used for the transaction has been unlocked inside
           *            the transaction
           * @exception TransactionException if transactions are not allowed, or there is not any current transaction
           */
  public void endTransaction () throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("endTransaction", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MonitorException:1.0"))
                    throw sensei.middleware.domains.MonitorExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/TransactionException:1.0"))
                    throw sensei.middleware.domains.TransactionExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                endTransaction (        );
            } finally {
                _releaseReply ($in);
            }
  } // endTransaction

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/DomainGroupHandler:1.0", 
    "IDL:sensei/middleware/gms/GroupHandler:1.0", 
    "IDL:sensei/middleware/gms/GroupMember:1.0", 
    "IDL:sensei/middleware/domains/PropertiesHandler:1.0", 
    "IDL:sensei/middleware/domains/SubgroupsHandler:1.0", 
    "IDL:sensei/middleware/domains/TransactionsHandler:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _DomainGroupHandlerStub
