/**
  * File: CoordinatorElectorBaseImpl.java
  * Content: Defines an abstract corba class to implement the CoordinatorElector interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the CoordinatorElector CORBA interface.
  **/
public abstract class CoordinatorElectorBaseImpl extends CoordinatorElectorPOA {

	public CoordinatorElectorBaseImpl() throws UserException {
		this(true);
	}

	public CoordinatorElectorBaseImpl(boolean active) throws UserException {
		if (active)
			activate();
	}

	public void activate() throws UserException {
		if (thisCoordinatorElector == null) {
			id = ORBcentral.getPOA().activate_object(this);
			thisCoordinatorElector = CoordinatorElectorHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
		}
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisCoordinatorElector != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisCoordinatorElector = null;
		}
	}

	public final CoordinatorElector theCoordinatorElector() {
		return thisCoordinatorElector;
	}

	protected CoordinatorElector thisCoordinatorElector;
	byte[] id;
};
