/**
  * File: DomainGroupUserBaseImpl.java
  * Content: Defines an abstract corba class to implement the DomainGroupUSer interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the DomainGroupUser CORBA interface.
  **/
public abstract class DomainGroupUserBaseImpl extends DomainGroupUserPOA {

	public DomainGroupUserBaseImpl() throws UserException {
		this(true);
	}

	public DomainGroupUserBaseImpl(boolean active) throws UserException {
		if (active)
			activate();
	}

	public void activate() throws UserException {
		if (thisDomainGroupUser == null) {
			id = ORBcentral.getPOA().activate_object(this);
			thisDomainGroupUser = DomainGroupUserHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
		}
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisDomainGroupUser != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisDomainGroupUser = null;
		}
	}

	public final DomainGroupUser theDomainGroupUser() {
		return thisDomainGroupUser;
	}

	protected DomainGroupUser thisDomainGroupUser;
	byte[] id;
};
