package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/GroupMembershipNamingServiceOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * The Group Member Naming Service is a naming service for reliable
        * Group Members. It allows to join groups just by specifying the
        * group name. This service will locate other members in the group,
        * or will just create the group.
        * This service is not compatible with the GroupMembershipBasicService,
        * members added to groups using that service are unknown on this
        * Naming Service.
        **/
public interface GroupMembershipNamingServiceOperations 
{

  /**
            * Creates a GroupHandlerFactoryCreator
            **/
  sensei.middleware.gmns.GroupHandlerFactoryCreator getFactoryCreator ();

  /**
            * Finds a group with the name specified and includes the member with the given name
            * The reference can be null if the member is no accesible to clients
            * @returns the group handler created, or null if this member has been considered by
            *  the group.
            * @exception MemberStateException if the member defining the service cannot contact
            *  other members and decide surely about the joining
            **/
  sensei.middleware.gms.GroupHandler findAndJoinGroup (String groupName, sensei.middleware.gmns.GroupHandlerFactory theFactory, String memberName, sensei.middleware.gmns.ReplicatedServer clientsReference) throws sensei.middleware.domains.MemberStateException, sensei.middleware.gmns.InvalidGroupHandlerFactoryException, sensei.middleware.gmns.GroupHandlerFactoryException;

  /**
            * Leaves a group. This method is not needed to be called, as the service can
            * discover by itself that a member has left the group, but it can speed up
            * other member's joining.
            **/
  void leaveGroup (String groupName, sensei.middleware.gms.GroupHandler member);

  /**
            * Returns the know references to a group, which can be still not valid. The list
            * is empty if there are no servers in the group or the group does not exist
            **/
  sensei.middleware.gmns.ReplicatedServer[] getGroup (String groupName) throws sensei.middleware.domains.MemberStateException;

  /**
            * Returns a specific reference of a member in the group. If
            * the group does not exist or it contains no such a member, null is returned
            **/
  sensei.middleware.gmns.ReplicatedServer getGroupServer (String groupName, String memberName) throws sensei.middleware.domains.MemberStateException;

  /**
            * Returns a reference to a member in the group, warrantied to be valid. Note that it can
            * get invalidated before the client received it.
            **/
  sensei.middleware.gmns.ReplicatedServer getValidGroupServer (String groupName) throws sensei.middleware.domains.MemberStateException;
} // interface GroupMembershipNamingServiceOperations
