package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/GroupMembershipNamingServicePOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * The Group Member Naming Service is a naming service for reliable
        * Group Members. It allows to join groups just by specifying the
        * group name. This service will locate other members in the group,
        * or will just create the group.
        * This service is not compatible with the GroupMembershipBasicService,
        * members added to groups using that service are unknown on this
        * Naming Service.
        **/
public abstract class GroupMembershipNamingServicePOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.gmns.GroupMembershipNamingServiceOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("getFactoryCreator", new java.lang.Integer (0));
    _methods.put ("findAndJoinGroup", new java.lang.Integer (1));
    _methods.put ("leaveGroup", new java.lang.Integer (2));
    _methods.put ("getGroup", new java.lang.Integer (3));
    _methods.put ("getGroupServer", new java.lang.Integer (4));
    _methods.put ("getValidGroupServer", new java.lang.Integer (5));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
            * Creates a GroupHandlerFactoryCreator
            **/
       case 0:  // sensei/middleware/gmns/GroupMembershipNamingService/getFactoryCreator
       {
         sensei.middleware.gmns.GroupHandlerFactoryCreator $result = null;
         $result = this.getFactoryCreator ();
         out = $rh.createReply();
         sensei.middleware.gmns.GroupHandlerFactoryCreatorHelper.write (out, $result);
         break;
       }


  /**
            * Finds a group with the name specified and includes the member with the given name
            * The reference can be null if the member is no accesible to clients
            * @returns the group handler created, or null if this member has been considered by
            *  the group.
            * @exception MemberStateException if the member defining the service cannot contact
            *  other members and decide surely about the joining
            **/
       case 1:  // sensei/middleware/gmns/GroupMembershipNamingService/findAndJoinGroup
       {
         try {
           String groupName = in.read_string ();
           sensei.middleware.gmns.GroupHandlerFactory theFactory = sensei.middleware.gmns.GroupHandlerFactoryHelper.read (in);
           String memberName = in.read_string ();
           sensei.middleware.gmns.ReplicatedServer clientsReference = sensei.middleware.gmns.ReplicatedServerHelper.read (in);
           sensei.middleware.gms.GroupHandler $result = null;
           $result = this.findAndJoinGroup (groupName, theFactory, memberName, clientsReference);
           out = $rh.createReply();
           sensei.middleware.gms.GroupHandlerHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.gmns.InvalidGroupHandlerFactoryException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.gmns.InvalidGroupHandlerFactoryExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.gmns.GroupHandlerFactoryException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.gmns.GroupHandlerFactoryExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Leaves a group. This method is not needed to be called, as the service can
            * discover by itself that a member has left the group, but it can speed up
            * other member's joining.
            **/
       case 2:  // sensei/middleware/gmns/GroupMembershipNamingService/leaveGroup
       {
         String groupName = in.read_string ();
         sensei.middleware.gms.GroupHandler member = sensei.middleware.gmns.GroupHandlerHelper.read (in);
         this.leaveGroup (groupName, member);
         out = $rh.createReply();
         break;
       }


  /**
            * Returns the know references to a group, which can be still not valid. The list
            * is empty if there are no servers in the group or the group does not exist
            **/
       case 3:  // sensei/middleware/gmns/GroupMembershipNamingService/getGroup
       {
         try {
           String groupName = in.read_string ();
           sensei.middleware.gmns.ReplicatedServer $result[] = null;
           $result = this.getGroup (groupName);
           out = $rh.createReply();
           sensei.middleware.gmns.ReplicatedServersListHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Returns a specific reference of a member in the group. If
            * the group does not exist or it contains no such a member, null is returned
            **/
       case 4:  // sensei/middleware/gmns/GroupMembershipNamingService/getGroupServer
       {
         try {
           String groupName = in.read_string ();
           String memberName = in.read_string ();
           sensei.middleware.gmns.ReplicatedServer $result = null;
           $result = this.getGroupServer (groupName, memberName);
           out = $rh.createReply();
           sensei.middleware.gmns.ReplicatedServerHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Returns a reference to a member in the group, warrantied to be valid. Note that it can
            * get invalidated before the client received it.
            **/
       case 5:  // sensei/middleware/gmns/GroupMembershipNamingService/getValidGroupServer
       {
         try {
           String groupName = in.read_string ();
           sensei.middleware.gmns.ReplicatedServer $result = null;
           $result = this.getValidGroupServer (groupName);
           out = $rh.createReply();
           sensei.middleware.gmns.ReplicatedServerHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gmns/GroupMembershipNamingService:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public GroupMembershipNamingService _this() 
  {
    return GroupMembershipNamingServiceHelper.narrow(
    super._this_object());
  }

  public GroupMembershipNamingService _this(org.omg.CORBA.ORB orb) 
  {
    return GroupMembershipNamingServiceHelper.narrow(
    super._this_object(orb));
  }


} // class GroupMembershipNamingServicePOA
