/**
  * File: GroupHandlerFactoryCreatorImpl.java
  * Content: Implementation of the GroupHandlerFactoryCreator class
  * Author: LuisM Pena
  * Date: 3nd December 2000
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

/**
  * Class (not interface) that creates GroupHandlerFactories on
  *	demand. This is not a remote object, the intention is to
  *	create the GroupHandler in the local memory belonging to the
  *	group member, and therefore avoid new points of failure.
  *	If the GroupHandler would be created directly by any of the
  *	membership services, the failure of the service would suppose
  *	the failure of the associated GroupMember
  **/
public abstract class GroupHandlerFactoryCreatorBaseImpl extends GroupHandlerFactoryCreator {
}
