/**
  * File: GroupMembershipBasicServiceBaseImpl.java
  * Content: Implementation of the GroupMembershipBasicService
  * Author: LuisM Pena
  * Date: 3nd December 2000
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the GroupMembershipBasicService
  **/
public abstract class GroupMembershipBasicServiceBaseImpl extends GroupMembershipBasicServicePOA {
	public GroupMembershipBasicServiceBaseImpl() throws UserException {
		id = ORBcentral.getPOA().activate_object(this);
		thisGroupMembershipBasicService = GroupMembershipBasicServiceHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisGroupMembershipBasicService != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisGroupMembershipBasicService = null;
		}
	}

	public final GroupMembershipBasicService theGroupMembershipBasicService() {
		return thisGroupMembershipBasicService;
	}

	protected GroupMembershipBasicService thisGroupMembershipBasicService;
	byte[] id;
};
