/**
  * File: GroupMembershipNamingServiceBaseImpl.java
  * Content: Implementation of the GroupMembershipNamingService
  * Author: LuisM Pena
  * Date: 3nd December 2000
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the GroupMembershipNamingService
  **/
public abstract class GroupMembershipNamingServiceBaseImpl extends GroupMembershipNamingServicePOA {
	public GroupMembershipNamingServiceBaseImpl() throws UserException {
		id = ORBcentral.getPOA().activate_object(this);
		thisGroupMembershipNamingService = GroupMembershipNamingServiceHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisGroupMembershipNamingService != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisGroupMembershipNamingService = null;
		}
	}

	public final GroupMembershipNamingService theGroupMembershipNamingService() {
		return thisGroupMembershipNamingService;
	}

	protected GroupMembershipNamingService thisGroupMembershipNamingService;
	byte[] id;
};
