/**
  * File: MapStringSetObserverBaseImpl.java
  * Content: Implementation of the MapStringSet
  * Author: LuisM Pena
  * Date: 18th November 2001
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the MapStringSet
  **/
public abstract class MapStringSetObserverBaseImpl extends MapStringSetObserverPOA {
	public MapStringSetObserverBaseImpl() throws UserException {
		id = ORBcentral.getPOA().activate_object(this);
		thisMapStringSetObserver = MapStringSetObserverHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisMapStringSetObserver != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisMapStringSetObserver = null;
		}
	}

	public final MapStringSetObserver theMapStringSetObserver() {
		return thisMapStringSetObserver;
	}

	protected MapStringSetObserver thisMapStringSetObserver;
	byte[] id;
};
