/**
  * File: SetMemberInfoBaseImpl.java
  * Content: Implementation of the SetMemberInfo
  * Author: LuisM Pena
  * Date: 18th November 2001
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import org.omg.CORBA.UserException;

import sensei.middleware.gms.ORBcentral;

/**
  * Implementation of the SetMemberInfo
  **/
public abstract class SetMemberInfoBaseImpl extends SetMemberInfoPOA {
	public SetMemberInfoBaseImpl() throws UserException {
		id = ORBcentral.getPOA().activate_object(this);
		thisSetMemberInfo = SetMemberInfoHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (thisSetMemberInfo != null)
				ORBcentral.getPOA().deactivate_object(id);
			thisSetMemberInfo = null;
		}
	}

	public final SetMemberInfo theSetMemberInfo() {
		return thisSetMemberInfo;
	}

	protected SetMemberInfo thisSetMemberInfo;
	byte[] id;
};
