package sensei.middleware.gms;


/**
* sensei/middleware/gms/GroupHandlerOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:19 PM CET
*/


/**
        * GroupHandler defines the interface that allows to the application to
        * make group communications.
        */
public interface GroupHandlerOperations 
{

  /**
            * Returns the GroupMemberId handled by this GroupHandler
            * If the member is not active, the returned value is random - negative.
            **/
  int getGroupMemberId ();

  /**
            * Returns true if the member belong to a group
            **/
  boolean isValidGroup ();

  /**
            * Leaves the group
            * @returns true if the member was belonging to a group
            **/
  boolean leaveGroup ();

  /**
            * Sends a message to every member in the view, returning
            * true if the message is sent on this view
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  boolean castMessage (sensei.middleware.gms.Message msg);

  /**
            * Sends a message to the specified member in the view, returning
            * true if the message is sent on this view. This call allows
            * to keep the order between cast and point-to-point messages
            * @param target The member receiving the message
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  boolean sendMessage (int target, sensei.middleware.gms.Message msg);
} // interface GroupHandlerOperations
