package sensei.middleware.gms;


/**
* sensei/middleware/gms/GroupMemberOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:19 PM CET
*/


/**
        * GroupMember specifies the interface to be implemented by group members
        */
public interface GroupMemberOperations 
{

  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
  void processPTPMessage (int sender, sensei.middleware.gms.Message msg);

  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
  void processCastMessage (int sender, sensei.middleware.gms.Message msg);

  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
  void memberAccepted (int identity, sensei.middleware.gms.GroupHandler handler, sensei.middleware.gms.View theView);

  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
  void changingView ();

  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
  void installView (sensei.middleware.gms.View theView);

  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
  void excludedFromGroup ();
} // interface GroupMemberOperations
