/**
  * File: GroupMemberImpl.java
  * Content: Implementation of the GroupMember CORBA interface.
  * Author: LuisM Pena
  * Date: 17th November 2000
  * Version: 0.80.00
  * Last change:
  *
  **/

package sensei.middleware.gms;

import org.omg.CORBA.UserException;

/**
  * Class implementing the CORBA interface for the GroupMember.
  **/
public abstract class GroupMemberImpl extends GroupMemberPOA {
	public GroupMemberImpl() throws UserException {
		this(true);
	}

	public GroupMemberImpl(boolean active) throws UserException {
		if (active)
			activate();
	}

	public void activate() throws UserException {
		if (thisGroupMember == null) {
			id = ORBcentral.getPOA().activate_object(this);
			thisGroupMember = GroupMemberHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
		}
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (id != null)
				ORBcentral.getPOA().deactivate_object(id);
			id = null;
		}
	}

	public final GroupMember theGroupMember() {
		return thisGroupMember;
	}

	protected GroupMember thisGroupMember;
	byte[] id;
};
