package sensei.middleware.gms;


/**
* sensei/middleware/gms/SenseiGMSMemberPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:30 PM CET
*/


/**
        * GMSMember specifies the interface that group members must
        * implement to enable the communications in the group.
        * The same member is a GroupHandler itself
        **/
public abstract class SenseiGMSMemberPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.gms.SenseiGMSMemberOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("receiveToken", new java.lang.Integer (0));
    _methods.put ("receiveView", new java.lang.Integer (1));
    _methods.put ("receiveMessages", new java.lang.Integer (2));
    _methods.put ("confirmMessages", new java.lang.Integer (3));
    _methods.put ("receivePTPMessages", new java.lang.Integer (4));
    _methods.put ("allowTokenRecovery", new java.lang.Integer (5));
    _methods.put ("recoverToken", new java.lang.Integer (6));
    _methods.put ("addGroupMember", new java.lang.Integer (7));
    _methods.put ("createGroup", new java.lang.Integer (8));
    _methods.put ("joinGroup", new java.lang.Integer (9));
    _methods.put ("getGroupMemberId", new java.lang.Integer (10));
    _methods.put ("isValidGroup", new java.lang.Integer (11));
    _methods.put ("leaveGroup", new java.lang.Integer (12));
    _methods.put ("castMessage", new java.lang.Integer (13));
    _methods.put ("sendMessage", new java.lang.Integer (14));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
            * The member receives the token. It is time to send any
            * queued messages or to install new views, and, after that,
            * transfer the token to the next member in the group.
            * @param sender The member sending the token
            * @param token  The token being passed
            * @returns true if the token is accepted.
            **/
       case 0:  // sensei/middleware/gms/SenseiGMSMember/receiveToken
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Token theToken = sensei.middleware.gms.TokenHelper.read (in);
         boolean $result = false;
         $result = this.receiveToken (sender, theToken);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * The member receives a new view. If the member is joining
            * the group, this view includes effectively the member in
            * the group, and its call to join will eventually return
            * with a succesfull flag
            * @param sender The member sending the token
            * @param view The new view to install
            * @param viewToken The token to be used by the group during the
            *        new view. If the new view has been generated after a
            *        recovery of a lost token, this token must be differente
            *        of the one used in the previous view
            * @returns true if the view is accepted
            **/
       case 1:  // sensei/middleware/gms/SenseiGMSMember/receiveView
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.InternalView view = sensei.middleware.gms.InternalViewHelper.read (in);
         sensei.middleware.gms.Token viewToken = sensei.middleware.gms.TokenHelper.read (in);
         boolean $result = false;
         $result = this.receiveView (sender, view, viewToken);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * The member receives new messages. They won't be processed immediately
            * (it's a two phase commit process)
            * @param sender The member sending the token
            * @param messages The array of messages to process
            * @param messageId an id for the group of messages
            * @returns true if the messages are accepted
            **/
       case 2:  // sensei/middleware/gms/SenseiGMSMember/receiveMessages
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message messages[] = sensei.middleware.gms.MessageListHelper.read (in);
         sensei.middleware.gms.MessageId msgId = sensei.middleware.gms.MessageIdHelper.read (in);
         boolean $result = false;
         $result = this.receiveMessages (sender, messages, msgId);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * The member receives the confirmation to previous messages.
            * @param sender The member sending the token
            * @param messageId an id for the group of messages
            * @returns true if the confirmation is valid
            **/
       case 3:  // sensei/middleware/gms/SenseiGMSMember/confirmMessages
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.MessageId msgId = sensei.middleware.gms.MessageIdHelper.read (in);
         boolean $result = false;
         $result = this.confirmMessages (sender, msgId);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * The member receives one or more point to point messages.
            * @param sender The member sending the token
            * @param messages The point to point messages to process
            * @param messageId It's only required the view information in the message id.
            *    * 	The id itself must be zero.
            * @return true if the message is accepted
            **/
       case 4:  // sensei/middleware/gms/SenseiGMSMember/receivePTPMessages
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message messages[] = sensei.middleware.gms.MessageListHelper.read (in);
         sensei.middleware.gms.MessageId msgId = sensei.middleware.gms.MessageIdHelper.read (in);
         boolean $result = false;
         $result = this.receivePTPMessages (sender, messages, msgId);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * This method is called by another member which thinks that
            * the token is lost and it's trying to recover it. There are
            * three possible answers, depending on the returning values and
            * the recover parameter.
            * @param sender The member trying to recover the token
            * @param myViewId the view id currently seen by the sender
            * @param recover includes the answer of this member to the
            *    try to recover the token
            * @returns true if it considers that the sender can recover the token
            **/
       case 5:  // sensei/middleware/gms/SenseiGMSMember/allowTokenRecovery
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.InternalViewId myViewId = sensei.middleware.gms.InternalViewIdHelper.read (in);
         sensei.middleware.gms.AllowTokenRecoveryAnswer $result = null;
         $result = this.allowTokenRecovery (sender, myViewId);
         out = $rh.createReply();
         sensei.middleware.gms.AllowTokenRecoveryAnswerHelper.write (out, $result);
         break;
       }


  /**
            * This method is called by another member which is recovering
            * the token; after this message is received, the token is considered
            * lost and no tokens or views will be accepted until a new view
            * is installed by the member who has sent this message.
            * @param sender The member trying to recover the token
            * @returns false if it doesn't accept the token recovery or the sender
            **/
       case 6:  // sensei/middleware/gms/SenseiGMSMember/recoverToken
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         boolean $result = false;
         $result = this.recoverToken (sender);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Joins the member to the current group where this member
            * is included. It blocks until the member is effectively
            * included in the group (it will also receive a view with
            * the members in the group).
            * @param other The member willing to join the group
            * @returns false if the member can not be included because
            *  the contacted GroupMember doesn't belong to any group
            */
       case 7:  // sensei/middleware/gms/SenseiGMSMember/addGroupMember
       {
         sensei.middleware.gms.SenseiGMSMember other = sensei.middleware.gms.SenseiGMSMemberHelper.read (in);
         boolean $result = false;
         $result = this.addGroupMember (other);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * This method starts a new group where the only member is this member. This member
            * cannot be part of any other group, or the creation will fail
            **/
       case 8:  // sensei/middleware/gms/SenseiGMSMember/createGroup
       {
         boolean $result = false;
         $result = this.createGroup ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * This method joins an existing group. This joining can fail, and in that case
            * it is returned false and this object is invalidated, that is, cannot be used
            * to join another member. It can fail as well if the member belonged already to
            * other group; in that case, the member is not invalidated (it can be checked
            * previously using validObject()).
            * This method will use addGroupMember on the specified goup, taking care of
            * the possible exclusion conditions.
            **/
       case 9:  // sensei/middleware/gms/SenseiGMSMember/joinGroup
       {
         sensei.middleware.gms.SenseiGMSMember group = sensei.middleware.gms.SenseiGMSMemberHelper.read (in);
         boolean $result = false;
         $result = this.joinGroup (group);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Returns the GroupMemberId handled by this GroupHandler
            * If the member is not active, the returned value is random - negative.
            **/
       case 10:  // sensei/middleware/gms/GroupHandler/getGroupMemberId
       {
         int $result = (int)0;
         $result = this.getGroupMemberId ();
         out = $rh.createReply();
         out.write_long ($result);
         break;
       }


  /**
            * Returns true if the member belong to a group
            **/
       case 11:  // sensei/middleware/gms/GroupHandler/isValidGroup
       {
         boolean $result = false;
         $result = this.isValidGroup ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Leaves the group
            * @returns true if the member was belonging to a group
            **/
       case 12:  // sensei/middleware/gms/GroupHandler/leaveGroup
       {
         boolean $result = false;
         $result = this.leaveGroup ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Sends a message to every member in the view, returning
            * true if the message is sent on this view
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
       case 13:  // sensei/middleware/gms/GroupHandler/castMessage
       {
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         boolean $result = false;
         $result = this.castMessage (msg);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Sends a message to the specified member in the view, returning
            * true if the message is sent on this view. This call allows
            * to keep the order between cast and point-to-point messages
            * @param target The member receiving the message
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
       case 14:  // sensei/middleware/gms/GroupHandler/sendMessage
       {
         int target = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         boolean $result = false;
         $result = this.sendMessage (target, msg);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gms/SenseiGMSMember:1.0", 
    "IDL:sensei/middleware/gms/GroupHandler:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public SenseiGMSMember _this() 
  {
    return SenseiGMSMemberHelper.narrow(
    super._this_object());
  }

  public SenseiGMSMember _this(org.omg.CORBA.ORB orb) 
  {
    return SenseiGMSMemberHelper.narrow(
    super._this_object(orb));
  }


} // class SenseiGMSMemberPOA
