package sensei.middleware.gms;


/**
* sensei/middleware/gms/_SenseiGMSMemberStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:30 PM CET
*/


/**
        * GMSMember specifies the interface that group members must
        * implement to enable the communications in the group.
        * The same member is a GroupHandler itself
        **/
public class _SenseiGMSMemberStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.gms.SenseiGMSMember
{


  /**
            * The member receives the token. It is time to send any
            * queued messages or to install new views, and, after that,
            * transfer the token to the next member in the group.
            * @param sender The member sending the token
            * @param token  The token being passed
            * @returns true if the token is accepted.
            **/
  public boolean receiveToken (int sender, sensei.middleware.gms.Token theToken)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("receiveToken", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.TokenHelper.write ($out, theToken);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return receiveToken (sender, theToken        );
            } finally {
                _releaseReply ($in);
            }
  } // receiveToken


  /**
            * The member receives a new view. If the member is joining
            * the group, this view includes effectively the member in
            * the group, and its call to join will eventually return
            * with a succesfull flag
            * @param sender The member sending the token
            * @param view The new view to install
            * @param viewToken The token to be used by the group during the
            *        new view. If the new view has been generated after a
            *        recovery of a lost token, this token must be differente
            *        of the one used in the previous view
            * @returns true if the view is accepted
            **/
  public boolean receiveView (int sender, sensei.middleware.gms.InternalView view, sensei.middleware.gms.Token viewToken)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("receiveView", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.InternalViewHelper.write ($out, view);
                sensei.middleware.gms.TokenHelper.write ($out, viewToken);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return receiveView (sender, view, viewToken        );
            } finally {
                _releaseReply ($in);
            }
  } // receiveView


  /**
            * The member receives new messages. They won't be processed immediately
            * (it's a two phase commit process)
            * @param sender The member sending the token
            * @param messages The array of messages to process
            * @param messageId an id for the group of messages
            * @returns true if the messages are accepted
            **/
  public boolean receiveMessages (int sender, sensei.middleware.gms.Message[] messages, sensei.middleware.gms.MessageId msgId)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("receiveMessages", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.MessageListHelper.write ($out, messages);
                sensei.middleware.gms.MessageIdHelper.write ($out, msgId);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return receiveMessages (sender, messages, msgId        );
            } finally {
                _releaseReply ($in);
            }
  } // receiveMessages


  /**
            * The member receives the confirmation to previous messages.
            * @param sender The member sending the token
            * @param messageId an id for the group of messages
            * @returns true if the confirmation is valid
            **/
  public boolean confirmMessages (int sender, sensei.middleware.gms.MessageId msgId)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("confirmMessages", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.MessageIdHelper.write ($out, msgId);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return confirmMessages (sender, msgId        );
            } finally {
                _releaseReply ($in);
            }
  } // confirmMessages


  /**
            * The member receives one or more point to point messages.
            * @param sender The member sending the token
            * @param messages The point to point messages to process
            * @param messageId It's only required the view information in the message id.
            *    * 	The id itself must be zero.
            * @return true if the message is accepted
            **/
  public boolean receivePTPMessages (int sender, sensei.middleware.gms.Message[] messages, sensei.middleware.gms.MessageId msgId)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("receivePTPMessages", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.MessageListHelper.write ($out, messages);
                sensei.middleware.gms.MessageIdHelper.write ($out, msgId);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return receivePTPMessages (sender, messages, msgId        );
            } finally {
                _releaseReply ($in);
            }
  } // receivePTPMessages


  /**
            * This method is called by another member which thinks that
            * the token is lost and it's trying to recover it. There are
            * three possible answers, depending on the returning values and
            * the recover parameter.
            * @param sender The member trying to recover the token
            * @param myViewId the view id currently seen by the sender
            * @param recover includes the answer of this member to the
            *    try to recover the token
            * @returns true if it considers that the sender can recover the token
            **/
  public sensei.middleware.gms.AllowTokenRecoveryAnswer allowTokenRecovery (int sender, sensei.middleware.gms.InternalViewId myViewId)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("allowTokenRecovery", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.InternalViewIdHelper.write ($out, myViewId);
                $in = _invoke ($out);
                sensei.middleware.gms.AllowTokenRecoveryAnswer $result = sensei.middleware.gms.AllowTokenRecoveryAnswerHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return allowTokenRecovery (sender, myViewId        );
            } finally {
                _releaseReply ($in);
            }
  } // allowTokenRecovery


  /**
            * This method is called by another member which is recovering
            * the token; after this message is received, the token is considered
            * lost and no tokens or views will be accepted until a new view
            * is installed by the member who has sent this message.
            * @param sender The member trying to recover the token
            * @returns false if it doesn't accept the token recovery or the sender
            **/
  public boolean recoverToken (int sender)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("recoverToken", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return recoverToken (sender        );
            } finally {
                _releaseReply ($in);
            }
  } // recoverToken


  /**
            * Joins the member to the current group where this member
            * is included. It blocks until the member is effectively
            * included in the group (it will also receive a view with
            * the members in the group).
            * @param other The member willing to join the group
            * @returns false if the member can not be included because
            *  the contacted GroupMember doesn't belong to any group
            */
  public boolean addGroupMember (sensei.middleware.gms.SenseiGMSMember other)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("addGroupMember", true);
                sensei.middleware.gms.SenseiGMSMemberHelper.write ($out, other);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return addGroupMember (other        );
            } finally {
                _releaseReply ($in);
            }
  } // addGroupMember


  /**
            * This method starts a new group where the only member is this member. This member
            * cannot be part of any other group, or the creation will fail
            **/
  public boolean createGroup ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("createGroup", true);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return createGroup (        );
            } finally {
                _releaseReply ($in);
            }
  } // createGroup


  /**
            * This method joins an existing group. This joining can fail, and in that case
            * it is returned false and this object is invalidated, that is, cannot be used
            * to join another member. It can fail as well if the member belonged already to
            * other group; in that case, the member is not invalidated (it can be checked
            * previously using validObject()).
            * This method will use addGroupMember on the specified goup, taking care of
            * the possible exclusion conditions.
            **/
  public boolean joinGroup (sensei.middleware.gms.SenseiGMSMember group)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("joinGroup", true);
                sensei.middleware.gms.SenseiGMSMemberHelper.write ($out, group);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return joinGroup (group        );
            } finally {
                _releaseReply ($in);
            }
  } // joinGroup


  /**
            * Returns the GroupMemberId handled by this GroupHandler
            * If the member is not active, the returned value is random - negative.
            **/
  public int getGroupMemberId ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getGroupMemberId", true);
                $in = _invoke ($out);
                int $result = sensei.middleware.gms.GroupMemberIdHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getGroupMemberId (        );
            } finally {
                _releaseReply ($in);
            }
  } // getGroupMemberId


  /**
            * Returns true if the member belong to a group
            **/
  public boolean isValidGroup ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("isValidGroup", true);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return isValidGroup (        );
            } finally {
                _releaseReply ($in);
            }
  } // isValidGroup


  /**
            * Leaves the group
            * @returns true if the member was belonging to a group
            **/
  public boolean leaveGroup ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("leaveGroup", true);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return leaveGroup (        );
            } finally {
                _releaseReply ($in);
            }
  } // leaveGroup


  /**
            * Sends a message to every member in the view, returning
            * true if the message is sent on this view
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  public boolean castMessage (sensei.middleware.gms.Message msg)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("castMessage", true);
                sensei.middleware.gms.MessageHelper.write ($out, msg);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return castMessage (msg        );
            } finally {
                _releaseReply ($in);
            }
  } // castMessage


  /**
            * Sends a message to the specified member in the view, returning
            * true if the message is sent on this view. This call allows
            * to keep the order between cast and point-to-point messages
            * @param target The member receiving the message
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  public boolean sendMessage (int target, sensei.middleware.gms.Message msg)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("sendMessage", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, target);
                sensei.middleware.gms.MessageHelper.write ($out, msg);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return sendMessage (target, msg        );
            } finally {
                _releaseReply ($in);
            }
  } // sendMessage

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gms/SenseiGMSMember:1.0", 
    "IDL:sensei/middleware/gms/GroupHandler:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _SenseiGMSMemberStub
