/**
  * File: SenseiGMSMemberImpl.java
  * Content: Implementation of the GroupMember CORBA interface.
  * Author: LuisM Pena
  * Date: 17th November 2000
  * Version: 0.80.00
  * Last change:
  *
  **/

package sensei.middleware.gms;

import org.omg.CORBA.UserException;

/**
  * Class implementing the CORBA interface for the GroupMember.
  **/
public abstract class SenseiGMSMemberImpl extends SenseiGMSMemberPOA {
	public SenseiGMSMemberImpl() throws UserException {
		this(true);
	}

	public SenseiGMSMemberImpl(boolean active) throws UserException {
		if (active)
			activate();
	}

	public void activate() throws UserException {
		if (thisSenseiGMSMember == null) {
			id = ORBcentral.getPOA().activate_object(this);
			thisSenseiGMSMember = SenseiGMSMemberHelper.narrow(ORBcentral.getPOA().id_to_reference(id));
		}
	}

	public void deactivate() throws UserException {
		synchronized (this) {
			if (id != null)
				ORBcentral.getPOA().deactivate_object(id);
			id = null;
		}
	}

	public final SenseiGMSMember theSenseiGMSMember() {
		return thisSenseiGMSMember;
	}

	SenseiGMSMember thisSenseiGMSMember;
	byte[] id;
};
