/**
  * File: 		PropertiesListener.java
  * Content: 	part of the RMI specification of sensei domains
  *           Defines the interface to be implemented by applications listening to property changes
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
  * Defines the interface to be implemented by applications listening to property changes
  */
public interface PropertiesListener extends Remote
{
  /**
   * Only are received the notifications from the members who update their properties.
   */
  public void propertiesUpdated (int loc) throws RemoteException;
}
