/**
  * File: 		SubgroupState.java
  * Content: 	part of the RMI specification of sensei domains
  *           Defines a structure associating for a subgroup id its phase coordination and state
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;

final public class SubgroupState implements java.io.Serializable
{
    public
    SubgroupState()
    {
    }

    public
    SubgroupState(int id,
                  PhaseCoordination phase,
                  State subState)
    {
        this.id = id;
        this.phase = phase;
        this.subState = subState;
    }

    public int id;
    public PhaseCoordination phase;
    public State subState;
}
