/**
  * File: GroupHandlerFactoryImpl.java
  * Content: Implementation of the GroupHandlerFactory
  * Author: LuisM Pena
  * Date: 		1st December 2001
  * Version:  0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import sensei.middleware.gms.GroupMember;

/**
  * Implementation of the GroupHandlerFactory
  **/
public abstract class GroupHandlerFactoryBaseImpl extends UnicastRemoteObject implements GroupHandlerFactory
{
  public GroupHandlerFactoryBaseImpl(GroupMember member) throws RemoteException
  {
    this.member = member;
    thisGroupHandlerFactory=this;
  }

  public void deactivate() throws RemoteException
  {
    synchronized (this)
    {
      if (thisGroupHandlerFactory!=null)
        unexportObject(thisGroupHandlerFactory,true);
      thisGroupHandlerFactory=null;
    }
  }

  public final GroupHandlerFactory theGroupHandlerFactory()
  {
    return thisGroupHandlerFactory;
  }


  protected GroupMember member;
  protected GroupHandlerFactory thisGroupHandlerFactory;
}
