/**
  * File: Trace.java
  * Content: Class to trace the GMNS events
  * Author: LuisM Pena
  * Date: 5th December 2000
  * Version: 0.29.00
  * Last change:
  *
  * Comments: This class is not intended to be included in the release
  *						version.
  **/

package sensei.gmns;

import sensei.util.SenseiError;
import sensei.util.logging.Logger;
/**
  * Class to trace the GMNS events
  **/
public class Trace {
	//***************************************************************************//
	//*****************  GENERAL PURPOSE TRACES *********************************//
	//***************************************************************************//

	public static void code(String code) {
		if (TRACE_CODE)
			print("Code:" + code);
	}

	public static void print(String message) {
		if (logger != null)
			logger.log(message);
	}

	public static void handledException(Exception ex) {
		if (TRACE && TRACE_EXCEPTIONS) {
			String s;
			if (TRACE_EXCEPTIONS_LONG_FORMAT)
				s = SenseiError.convertExceptionToString(ex);
			else
				s = ex.toString();
			print(s);
		}
	}

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
	//+++++++++++++++++  TRACE VARIABLES ++++++++++++++++++++++++++++++++++++++++//
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

	static final boolean TRACE = sensei.util.Configuration.getSingleton().traceGMNS();
	static final boolean TRACE_CODE = sensei.util.Configuration.getSingleton().traceGMNSCode();
	static final boolean TRACE_EXCEPTIONS = sensei.util.Configuration.getSingleton().traceExceptionsGMNS();
	static final boolean TRACE_EXCEPTIONS_LONG_FORMAT = sensei.util.Configuration.getSingleton().traceExceptionsDetailedGMNS();

	static final Logger logger = Logger.getLogger(Consts.AREA, TRACE);

}
