/**
  * File: RecoverTokenChannelRequester.java
  * Content: Defines a channel requester to recover the token
  * Author: LuisM Pena
  * Date: 1st August2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import java.io.IOException;

import sensei.middleware.gms.SenseiGMSMember;

//*************************************************************************************//
//**************************** RECOVER TOKEN CHANNEL REQUESTER ************************//
//*************************************************************************************//

/**
  * Channel Requester used to sends requests to recover the token
  **/
class RecoverTokenChannelRequester extends ChannelRequester {
	public RecoverTokenChannelRequester(int thisMember) {
		Trace.code("RecoverTokenChannelRequester.java -> RecoverTokenChannelRequester ( int thisMember )");
		this.thisMember = thisMember;
	}

	public boolean invokeMember(SenseiGMSMember channelMember) throws IOException{
		Trace.code("RecoverTokenChannelRequester.java -> boolean invokeMember ( SenseiGMSMember channel )");

		return channelMember.recoverToken(thisMember);
	}

	int thisMember;
}
