/**
  * File: SendTokenChannelRequester.java
  * Content: Defines a channel requester to send the token
  * Author: LuisM Pena
  * Date: 1st August 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import java.io.IOException;

import sensei.middleware.gms.SenseiGMSMember;
import sensei.middleware.gms.Token;

/**
  * Defines a channel requester to send the token
  **/
class SendTokenChannelRequester extends ChannelRequester {

	public SendTokenChannelRequester(int thisMember) {
		Trace.code("SendTokenChannelRequester.java -> SendTokenChannelRequester ( int thisMember )");
		this.thisMember = thisMember;
	}

	public void setTokenToSend(Token token) {
		Trace.code("SendTokenChannelRequester.java -> void setTokenToSend ( Token token )");
		this.token = token;
	}

	public boolean invokeMember(SenseiGMSMember channelMember) throws IOException{
		Trace.code("SendTokenChannelRequester.java -> boolean invokeMember ( SenseiGMSMember channel ) on "+channelMember.getGroupMemberId());

		assert token != null;

		return channelMember.receiveToken(thisMember, token);
	}

	int thisMember;
	Token token;
}
