/**
  * File: SendViewChannelRequester.java
  * Content: Defines a channel requester to send a view
  * Author: LuisM Pena
  * Date: 1st August 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import java.io.IOException;

import sensei.middleware.gms.InternalView;
import sensei.middleware.gms.SenseiGMSMember;
import sensei.middleware.gms.Token;

//*************************************************************************************//
//**************************** SEND VIEW CHANNEL REQUESTER ****************************//
//*************************************************************************************//

/**
  * Channel Requester used to send views
  **/
class SendViewChannelRequester extends ChannelRequester {

	public SendViewChannelRequester(int thisMember) {
		Trace.code("SendViewChannelRequester.java -> SendViewChannelRequester ( int thisMember )");
		this.thisMember = thisMember;
	}

	public void setInfoToSend(InternalView view, Token token) {
		Trace.code("SendViewChannelRequester.java -> void setInfoToSend ( InternalView view , Token token )");
		this.view = view;
		this.token = token;
	}

	public boolean invokeMember(SenseiGMSMember channelMember) throws IOException{
		Trace.code("SendViewChannelRequester.java -> boolean invokeMember ( SenseiGMSMember channel )");

		assert view != null && token != null;

		return channelMember.receiveView(thisMember, view, token);
	}

	int thisMember;
	Token token;
	InternalView view;
}
