package sensei.util;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * @author lpena
 */
public class ExceptionMessageBox extends JDialog implements ActionListener {

	ExceptionMessageBox(Throwable ex, String title) {
		JPanel panel = new JPanel(new BorderLayout());
		JPanel top = new JPanel(new BorderLayout());
		JPanel error = new JPanel(new BorderLayout());
		JButton ok = new JButton("Ok");
		JTextArea text = new JTextArea();
		ok.addActionListener(this);
		error.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Error"));
		
		String what = ex.getMessage();
		if (what==null) what=ex.toString();
		
		error.add(new JLabel(what), BorderLayout.CENTER);
		top.add(error, BorderLayout.CENTER);
		top.add(ok, BorderLayout.EAST);
		panel.add(top, BorderLayout.NORTH);
		panel.add(new JScrollPane(text), BorderLayout.CENTER);

		StackTraceElement ste[] = ex.getStackTrace();
		for (int i = 0; i < ste.length; i++) {
			if (i > 0) {
				text.append("\n");
			}
			text.append(ste[i].toString());
		}

		setTitle(title);
		getContentPane().add(panel);
	}

	public void actionPerformed(ActionEvent arg0) {
		dispose();
	}

	public static void printStackTrace(Throwable ex) {
		printStackTrace(ex, "Exception");
	}

	public static void printStackTrace(Throwable ex, String message) {
		ExceptionMessageBox box = new ExceptionMessageBox(ex, message);
		box.pack();
		box.show();
	}

}
